(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)





















































Off[General::"spell"]

Off[General::"spell1"]

BeginPackage["CurvesGraphics`","Utilities`FilterOptions`","Graphics`Arrow`",
    "Graphics`FilledPlot`","Graphics`PlotField`",
    "DrawGraphics`DrawingMaster`"];

Unprotect["`*"];
ClearAll["`*"];



Oriented::usage=
    "Oriented is an option for Plot, ParametricPlot, Plot3D, \
ParametricPlot3D, ContourPlot, PlotCurveOnSurface, TrigInterpolationPlot, \
TrigInterpolationParametricPlot, NDSolve, PhasePlot, LinearPhasePlot2D, \
LevelPlot3D, SliceSurfacePlot, and their Draw couterparts. With \
Oriented->True the curves will come out with arrows along them";

HowManyArrows::usage=
    "HowManyArrows is an option for Plot, ParametricPlot, ParametricPlot3D, \
and other functions that accept the Oriented option, that directs how many \
arrows to add along the curve. The default is HowManyArrows->Automatic, which \
is based on the ratio of the length of the curve(s) to the longest side of \
the smallest Rectangle (or Cuboid) that contains the curve(s) (see also \
ArrowDensity). When more than one curve is drawn at the same time, \
HowManyArrows accepts a list of values, that will be applied cyclically to \
the curves.";

ArrowPositions::usage=
    "ArrowPositions->{p1,p2,...} is an option for Plot, ParametricPlot, \
ParametricPlot3D, and other functions that accept the Oriented option \
(ContourPlot not included), that directs where to draw the arrows heads along \
the curve. The values p1,p2,... are supposed to be numbers between 0 and 1 \
(otherwise they are normalized automatically), and refer to the curve \
parameterized by arc length. The default is ArrowPositions->Automatic, under \
which the lengths of the arcs between the first or last arrow and the end \
point is d, while the arcs between successive arrow heads are 2d. This \
arrangement is best for closed cuves, as all successive arrows are separated \
by arcs of the same length.";

ReverseOrientation::usage=
    "ReverseOrientation is an option for Plot, ParametricPlot, \
ParametricPlot3D, and other functions that accept the Oriented option. When \
set to True, the orientation of the arrows gets reversed. The default is \
ReverseOrientation->False.";

ArrowDensity::usage=
    "ArrowDensity is an option for Plot, ParametricPlot, ParametricPlot3D, \
and other functions that accept the Oriented option, influencing how many \
arrows to draw along the lines. The number of arrows increases with the value \
of ArrowDensity. The default value is ArrowDensity->1.";

ArrowShaftLength::usage=
    "ArrowShaftLength is an option for Plot, ParametricPlot, \
ParametricPlot3D, and other functions that accept the Oriented option. It \
sets how long the arrow shafts should be, in the original coordinates of the \
graph (not scaled). Do not confuse this with the arrow head length. You may \
need to tweak ArrowShaftLength if your lines have hight curvature, or the \
AspectRatio is far from Automatic.";

ArrowsAcrossSubdivisions::usage=
    "ArrowsAcrossSubdivisions is an option for Plot, ParametricPlot, \
ParametricPlot3D, and other functions that accept the Oriented option. The \
default is ArrowsAcrossSubdivisions->True. When set to False, each arrow \
shaft placed along the curve will be contained in a single one of the \
straight line segments the Line is made of. This may help improve the look of \
a picture. Try also ArrowShaftLength.";

Arrow3DColor::usage=
    "Arrow3DColor is an option for ParametricPlot3D, LevelPlot3D and other \
functions that draw 3D arrows. The default is Arrow3DColor->Automatic,which \
means the same color as the curve along which the arrow is placed, typically \
black. Arrow3DColor->{} will make 3D arrows with no intrinsic color, just \
like any other surface.";

Arrow3DEdgeForm::usage=
    "Arrow3DEdgeForm is an option for ParametricPlot3D, LevelPlot3D and other \
functions that draw 3D arrows. It instructs how to draw the edges of the \
triangles the 3D arrows are made of. The default is \
Arrow3DEdgeForm\[Rule]EdgeForm[], that is, edges are not drawn.";



OrientedPlot::usage=
    "OrientedPlot[f[x],{x,xMin,xMax},opts] makes a Plot and then adds arrows \
along the curve. Specific options are HowManyArrows, ArrowPositions, \
ReverseOrientation. It also accepts options from Plot and Graphics`Arrow`. By \
default HeadScaling->Automatic and HeadLength->1/20.";

OrientedParametricPlot::usage=
    "OrientedParametricPlot[{x[t],y[t]},{t,tMin,tMax},opts] makes a \
ParametricPlot and then adds arrows along the curve. Specific options are \
HowManyArrows, ArrowPositions, ReverseOrientation. It also accepts options \
from ParametricPlot and Graphics`Arrow`. By default HeadScaling->Automatic \
and HeadLength->1/20.";

OrientedParametricPlot3D::usage=
    "OrientedParametricPlot3D[{x[t],y[t],z[t]},{t,tMin,tMax},opts] makes a \
ParametricPlot3D and then adds arrows along the curve. Specific options \
include HowManyArrows, ArrowPositions, ReverseOrientation. It also accepts \
options from ParametricPlot3D. DrawGraphics`DrawingArrows`. \
HeadScaling3D->Absolute by default and HeadLength3D->1/20.
OrientedParametricPlot3D[{x[t,u],y[t,u],z[t,u]},{t,tMin,tMax},{u,uMin,uMax},\
opts] makes a ParametricPlot3D of the surface, and then adds arrows along its \
boundary, in a counterclockwise (in the t-u space) direction.";

OrientedPlot3D::usage=
    "OrientedParametricPlot3D[f[x,y],{x,xMin,xMax},{y,yMin,yMax},opts] makes \
a Plot3D of the surface, and then adds arrows along its boundary, in a \
counterclockwise (in the t-u space) direction.";

HamiltonianPlot::usage=
    "HamiltonianPlot[f[x,y],{x,xMin,xMax},{y,yMin,yMax},opts] is the function \
that takes over ContourPlot when this has the option Oriented->True";



TrigInterpolation::usage=
    "TrigInterpolation[data,var] attempts to find a trigonometric function \
that interpolates exactly between the data. The data format is the same as \
for InterpolatingPolynomial. Options are EvaluateOnCoefficients and Period";

EvaluateOnCoefficients::usage=
    "EvaluateOnCoefficients is an option for TrigInterpolation, \
TrigInterpolationPlot and similar. It specifies what transformation to make \
on the coefficients of the trigonometric expression. A typical value may be \
EvaluateOnCoefficients->Simplify.";

Period::usage=
    "Period is an option for TrigInterpolation, TrigInterpolationPlot and \
similar. It specifies the (joint) period of the trigonometric functions that \
will make up the interpolation. The default is Period->Automatic";

ParametricTrigInterpolation::usage=
    "ParametricTrigInterpolation[data,t] attempts to find a trigonometric \
function that interpolates exactly between the data. The data structure is a \
list, of which each element is either a pair (or triplet) of numbers or a \
list of pairs (or triplets)";

TrigInterpolationPlot::usage=
    "TrigInterpolationPlot[data,xMin,xMax,opts] attempts to find a \
trigonometric function that interpolates exactly between the data and then \
plots its graph between xMin and xMax. The data have the same syntax as for \
InterpolatingPolynomial. It takes the options from Plot and from \
TrigInterpolation, plus ShowFormula, ShowListPlot, ListPlotStyle.";

TrigInterpolationDraw::usage=
    "TrigInterpolationDraw[data,xMin,xMax,opts] is the DrawGraphics companion \
to TrigInterpolationPlot";

TrigInterpolationParametricPlot::usage=
    "TrigInterpolationParametricPlot[data] is attempts to find a \
trigonometric function that interpolates exactly between the data and then \
plot its parametric graph. The data structure is a list, of which each \
element is either a pair (or triplet) of numbers or a list of pairs (or \
triplets). In case of pairs the plot will be 2-dimensional, otherwise it will \
be 3-dimensional. With the option ClosedCurve->True the plot will be a closed \
curve (a loop). It takes also the options from Plot and from \
TrigInterpolation, plus ShowFormula, ShowListPlot, ListPlotStyle.";

TrigInterpolationParametricDraw::usage=
    "TrigInterpolationParametricDraw[data] is the DrawGraphics companion to \
TrigInterpolationParametricPlot";

TrigInterpolationParametricPlot3D::usage=
    "TrigInterpolationParametricPlot3D[3Ddata,opts] is just \
TrigInterpolationParametricPlot but for 3D curves only. It is provided only \
for naming symmetry.";

TrigInterpolationParametricDraw3D::usage=
    "TrigInterpolationParametricDraw[data] is the DrawGraphics companion to \
TrigInterpolationParametricPlot3D";

PolynomialLevelSetTrigInterpolation::usage=
    "PolynomialLevelSetTrigInterpolation[2Ddata,t,x,y,opts] attempts to find \
a two-variable polynomial whose 0-level set interpolates the given data. The \
output will be a couple: the first element is the output of \
ParametricTrigInterpolation[2Ddata,t,opts], while the second element will be \
a polynomial in x and y.";

ShowListPlot::usage=
    "ShowListPlot is an option for TrigInterpolationPlot and \
TrigInterpolationParametricPlot. When ShowListPlot->True, the data points \
will be displayed along the curve.";

ListPlotStyle::usage=
    "ListPlotStyle is an option for TrigInterpolationPlot and \
TrigInterpolationParametricPlot. It specifies the style of the data points \
that are drawn when ShowListPlot is set to True";

ClosedCurve::usage=
    "ClosedCurve is an option for TrigInterpolationParametricPlot. The \
default is TrigInterpolationParametricPlot->False. When \
TrigInterpolationParametricPlot->True the curve will be closed (a loop).";

FilledClosedCurve::usage=
    "FilledClosedCurve is an option for TrigInterpolationParametricPlot, in \
the 2D case. The default is FilledClosedCurve->False. When \
FilledClosedCurve->True the curve will be closed (a loop) and it will be \
shown filled. The color is specified with the option Fills from \
Graphics`FilledPlot`";

ShowFormula::usage=
    "ShowFormula is an option for TrigInterpolationPlot and \
TrigInterpolationParametricPlot. The default is ShowFormula->False. If \
ShowFormula->True, the output will be a couple with first the graphics output \
and then the output of TrigInterpolation or ParametricTrigInterpolation.";



LevelPlot3D::usage=
    "LevelPlot3D[f,{x,x0,x1},{y,y0,y1}] draws a 3D plot of the function f \
with the level sets emphasized. You can control the number (or precise \
position) of level sets to be drawn with the option Contours. Example: \
LevelPlot3D[x^2+y^2,{x,-1,1},{y,-1,1},PlotPoints->11,Contours->5}].";

LevelDraw3D::usage=
    "LevelDraw3D[f,{x,x0,x1},{y,y0,y1}] extract the Graphics primitives from \
LevelPlot3D, suppressing the display.";

SliceSurfacePlot3D::usage=
    "SliceSurfacePlot3D[3DSurface, LinearForm,variables] draws on the surface \
the level sets of the LinearForm. You can control how many level sets (or \
their precise values) with the option Contours. Example: \
SliceSurfacePlot3D[Plot3D[Sin[x*y],{x,0,Pi},{y,0,Pi}],x+y,x,y,z].";

SliceSurface::usage=
    "SliceSurface[3DSurface, LinearForm,variables] is an obsolete name for \
SliceSurfacePlot3D, retained for backward compatibility.";

SliceSurface=SliceSurfacePlot3D;

SliceSurfaceDraw3D::usage=
    "SliceSurfaceDraw3D[3DSurface, LinearForm,variables] is the DrawGraphics \
companion to SliceSurfacePlot3D.";

LinearClipPlot3D::usage=
    "LinearClipPlot3D[3DSurface, LinearInequality,variables] shows the part \
of the surface that lies in the half-plane defined by the linear inequality. \
Example: LinearClipPlot3D[Plot3D[Sin[x*y],{x,0,Pi},{y,0,Pi}],x+y>=8z,x,y,z].";

LinearClip::usage=
    "LinearClip[3DSurface, LinearInequality,variables] is an obsolete name \
for LinearClipPlot3D, retained for backward compatibility.";

LinearClip=LinearClipPlot3D;

LinearClipDraw3D::usage=
    "LinearClipDraw3D[3DSurface, LinearInequality,variables] is the \
DrawGraphics companion to LinearPlot3D].";

PrepareForSlices::usage=
    "PrepareForSlices is an option for LinearClipPlot3D, specifying whether \
to keep both the two parts of the surface when cutting with a plane. It can \
take the values True or False.";

SurfaceStyle::usage=
    "SurfaceStyle is an option for SliceSurfacePlot3D and LevelPlot3D, \
containing the Graphis3D directives to affect the appearance of the surface.";

ShowProjectedLevelSets::usage=
    "ShowProjectedLevelSets is an option for LevelPlot3D and \
SliceSurfacePlot3D. When set to True, the level sets will be shown both on \
the 3D surface and as orthogonally projected onto a horizontal plane (or onto \
a level plane of the linear form in the SliceSurfacePlot3D case). The z-level \
of the plane is controlled with ProjectAt. The default is \
ShowProjectedLevelSets->False";

ProjectAt::usage=
    "ProjectAt is an option for LevelPlot3D and SliceSurfacePlot3D. \
ProjectAt->realNumber tells at what z-level (or linear form level) to draw \
the projected level sets. The default is ProjectAt->0";



PlotCurveOnSurface3D::usage=
    "PlotCurveOnSurface3D[surface,curve1,curve2,...,options] draws the curves \
on the surface adding plot points to the curve as to avoid disappearance of \
the curves behind the surface. The surface can be specified as in either \
Plot3D or ParametricPlot3D. The curves are expressed in the parameter space \
of the surface. Example: \
PlotCurveOnSurface3D[{x^2+y^2,{x,-1,1},{y,-1,1}},{{Cos[t],Sin[t]},{t,0,2Pi},\
PlotPoints->41}].";

CurveOnSurface::usage=
    "CurveOnSurface[surface,curve1,curve2,...,options] is an obsolete name \
for PlotCurveOnSurface3D. It is retained for backward compatibility.";

CurveOnSurface=PlotCurveOnSurface3D;

DrawCurveOnSurface3D::usage=
    "DrawCurveOnSurface3D[surface,curve1,curve2,...,options] is the \
DrawGraphics companion to PlotCurveOnSurface3D.";

ContourPlotOnSurface3D::usage=
    "ContourPlotOnSurface3D[surface,contourPlot1,...,options] .";



NDSolvePlot::usage=
    "NDSolvePlot[differential equations,options] is the engine of NDSolve \
when given the option PlotSolution->True. It solves the equations with \
NDSolve and then draws a plot of the solution. For a planar system the plot \
has arrows on it. The output is a couple {Graphics,NDSolve output}. It takes \
all options of NDSolve and OrientedParametricPlot.";

PlotSolution::usage=
    "PlotSolution is a new option for NDSolve. If it is set to True and the \
unknown functions are at most 3, then the output of NDSolve becomes a list of \
the form {solution, graph of the solution}";

DrawSolution::usage=
    "DrawSolution is a new option for NDSolve, the DrawGraphics companion to \
PlotSolution. If it is set to True and the unknown functions are at most 3, \
then the output of NDSolve becomes a list of the form {solution, graphics \
primitives of the graph of the solution}";



LinearPhasePlot2D::usage=
    "LinearPhasePlot2D[matrix,options] plots a phase portrait of the system \
of two differential equations {x'[t],y'[t]}==mat.{x[t],y[t]}. The matrix must \
be numeric and exact. The curves are drawn from the exact symbolic solutions \
of the system. Options are NotableLineStyle, NumberOfTrajectories, \
WriteReport, ShowField, Oriented, ArrowDensity. LinearPhasePlot2D also \
accepts all options for Graphics`Arrow` and Graphics. Example: \
LinearPhasePlot2D[{{1,2}},{-2,1}}].";

LinearPhasePlot::usage=
    "LinearPhasePlot is the older name of LinearPhasePlot2D, retained for \
backward compatibility.";

NotableLineStyle::usage=
    "NotableLineStyle is an option for LinearPhasePlot2D specifying how to \
highlight the straight lines that are of special significance for the system \
(either eigenspaces or principal directions). The default value is \
NotableLineStyle->RGBColor[1,0,0].";

NumberOfTrajectories::usage=
    "NumberOfTrajectories is an option for LinearPhasePlot2D that helps \
control how many trajectories to (attempt to) draw, approximately. The \
default value is NotableLineStyle->5.";

WriteReport::usage=
    "WriteReport is an option for LinearPhasePlot2D specifying whether to \
write the classification of the given system. The default value is \
WriteReport->True.";

ShowField::usage=
    "ShowField is an option for PhasePlot, LinearPhasePlot2D and ContourPlot \
specifying whether to draw the direction field of the system (by means of the \
package Graphics`PlotField`) together with the trajectories. The default \
value is ShowField->False.";

PhasePlot::usage=
    "PhasePlot[{f[x,y],g[x,y]},{x,xMin,xMax},{y,yMin,yMax},{tMin,tMax},\
options] makes a phase portrait of the system \
{x'[t]==f[x[t],y[t]],y'[t]==g[x[t],y[t]]}. Specific options are PlotPoints \
(that controls how many points there are in the initial values grid), \
InitialPoints, Oriented. It also accepts NDSolve, Graphics`Arrow` and \
Graphics options.";

PhaseDraw::usage=
    "PhaseDraw[{f[x,y],g[x,y]},{x,xMin,xMax},{y,yMin,yMax},{tMin,tMax},\
options] is the DrawGraphics companion to PhasePlot.";

InitialPoints::usage=
    "InitialPoints is an option for PhasePlot: it takes as value a list of \
points in 2D or 3D that are to be the starting points for the trajectories.";

GridPoints::usage=
    "GridPoints is an option for PhasePlot: it takes as value an integer or a \
list of two or three integers, stating the dimensions of the grid of starting \
points for the trajectories.";





Begin["`Private`"];

OrientedCurve=Oriented;
OrientedContour=Oriented;





lineLength[pts_List]:=
    Apply[Plus,Sqrt[Apply[Plus,Rest[pts-RotateRight[pts]]^2,1]]];



successiveLengths[pts_List]:=Map[lineLength,Rest[FoldList[Append,{},pts]]];



byArcLength[pts_List]:=
    Module[{withoutDuplicates=
          pts//.{a___,b_List,b_,c___}\[RuleDelayed]{a,b,c},divisionPointsNo},
      divisionPointsNo=
        Length[successiveLengths[
              withoutDuplicates]//.{a___,b_List,b_,c___}\[RuleDelayed]{a,b,
                c}];
      Function[{t},
        Evaluate[
          Through[Map[
                Interpolation[
                    Transpose[{successiveLengths[
                            withoutDuplicates],#}]//.({a___List,{b_?NumericQ,
                              c_},{b_,d_},e___})\[RuleDelayed]{a,{b,c},e},
                    InterpolationOrder\[Rule]If[divisionPointsNo>1,1,0]]&,
                Transpose[withoutDuplicates]][t]]]]];



colorSpecPattern=_CMYColor|_CMYKColor|_GrayLevel|_Hue|_RGBColor;



Options[insertArrows]={ArrowShaftLength\[Rule]1/1000,
      Arrow3DColor\[Rule]Automatic,Arrow3DEdgeForm\[Rule]EdgeForm[],
      ReverseOrientation\[Rule]False,ArrowsAcrossSubdivisions\[Rule]True,
      PlotStyle\[Rule]Automatic};

insertArrows[pts_List,{},opts___?OptionQ]:=Sequence@@{};

insertArrows[pts_List/;lineLength[pts]>$MachineEpsilon,positions_List,
      opts___?OptionQ]:=
    Module[{dim=Length@First@pts,el=lineLength[N@pts],revQ,acrossQ,
        arw3Dedgfrm,arwDelta,pltSty,arw3Dclr,ptsFinal,par,normalizedPlotPts,
        subdivisionInterval,arw,delta,arrowBase,arrowTip},
      {revQ,acrossQ}=
        Map[TrueQ,{ReverseOrientation,
                ArrowsAcrossSubdivisions}/.{opts}/.Options[insertArrows]];
      {arw3Dedgfrm,arwDelta,pltSty,
          arw3Dclr}={Arrow3DEdgeForm,ArrowShaftLength,PlotStyle,
              Arrow3DColor}/.{opts}/.Options[insertArrows];
      pltSty=Cases[pltSty,colorSpecPattern,{0,1}];
      If[arw3Dclr===Automatic,
        If[pltSty==={},arw3Dclr=GrayLevel[0],arw3Dclr=Last[pltSty]]];
      If[Not[TrueQ[arwDelta>0]],
        arwDelta=ArrowShaftLength/.Options[insertArrows]];
      ptsFinal=If[TrueQ[revQ],Reverse[pts],pts];
      par=byArcLength[N@ptsFinal];
      normalizedPlotPts=
        Flatten@Cases[par/.InterpolatingFunction\[Rule]intFunc,
              intFunc[_,_,{s_},___][___]\[RuleDelayed]s,{0,Infinity},1]/el;
      subdivisionInterval[t_]:=
        First@Cases[
            Partition[normalizedPlotPts,2,1],{a_,b_}/;
              a\[LessEqual]t\[LessEqual]b,1];
      arw=
        Which[dim\[Equal]2,Arrow,dim\[Equal]3,
          DrawGraphics`DrawingArrows`Arrow3D];
      halfDelta=If[dim\[Equal]2,arwDelta/2,
          
          DrawGraphics`DrawingArrows`HeadLength3D*
                DrawGraphics`DrawingArrows`HeadScaling3D/2/.{opts}/.Options[
              DrawGraphics`DrawingArrows`Arrow3D]];
      arrowBase[t_/;acrossQ]:=Max[el*t-halfDelta,0];
      arrowBase[t_/;Not@acrossQ]:=
        el*Max[First@subdivisionInterval[t],t-halfDelta/el];
      arrowTip[t_/;acrossQ]:=Min[el*t+halfDelta,el];
      arrowTip[t_/;Not@acrossQ]:=
        el*Min[t+halfDelta/el,Last@subdivisionInterval[t]];
      {If[dim\[Equal]3,
          Sequence@@{If[arw3Dclr===None,Sequence@@{},
                SurfaceColor[Sequence@@Flatten[{arw3Dclr}]]],arw3Dedgfrm},
          Sequence@@{}],
        Map[(arw[par[arrowBase[#]],par[arrowTip[#]],
                FilterOptions[arw,HeadScaling\[Rule]Automatic,opts]])&,
          positions]}];



insertArrows[pts_List/;lineLength[pts]\[LessEqual] $MachineEpsilon,
      positions_List,opts___?OptionQ]:=Sequence@@{};



normalizedArrowPositions[
      pos_/;And[pos=!=Automatic,
          MatchQ[pos,({u__/;Element[{u},Reals]})|(v_/;Element[v,Reals])]],_]:=
    Flatten[{(pos-Min[pos,0])/(Max[pos,1]-Min[pos,0])}];
normalizedArrowPositions[Automatic,howMany_Integer]:=
    Range[1,2howMany-1,2]/(2Max[howMany,1]);
normalizedArrowPositions[Automatic,howMany_]:={};
normalizedArrowPositions[
    pos_/;And[pos=!=Automatic,
        Not@MatchQ[
            pos,({u__/;Element[{u},Reals]})|(v_/;Element[v,Reals])]],_]:={}



maxLineExcursion[gr_]:=
    Max[0,Max@@
        Cases[gr,
          Line[pts_]\[RuleDelayed]Max@Map[Max[#]-Min[#]&,Transpose[pts]],{0,
            Infinity}]];

Options[automaticHeadScaling3D]={DrawGraphics`DrawingArrows`HeadScaling3D\
\[Rule]Automatic};
automaticHeadScaling3D[gr_,opts___?OptionQ]:=
    Module[{maxExcursion,scalingFromOpts},
      maxExcursion=maxLineExcursion[gr];
      scalingFromOpts=
        DrawGraphics`DrawingArrows`HeadScaling3D/.{opts}/.Options[
            automaticHeadScaling3D];
      DrawGraphics`DrawingArrows`HeadScaling3D\[Rule]
        If[TrueQ[scalingFromOpts\[GreaterEqual]0],scalingFromOpts,
          maxExcursion]];



sortOutHowManyArrows[graf_,declaredHowMany_,referenceDimension_,
      arrowDensityParameter_]:=Module[{automaticHowMany,howMany},
      automaticHowMany:=
        Cases[graf,
          Line[pts_List]\[RuleDelayed]
            Ceiling[If[TrueQ[arrowDensityParameter\[GreaterEqual]0],
                  arrowDensityParameter,1]*
                lineLength[pts]/referenceDimension],{1,Infinity}];
      Which[declaredHowMany===Automatic,howMany=automaticHowMany,
        Length[declaredHowMany]\[Equal]0,howMany={declaredHowMany},
        True,howMany=declaredHowMany];
      If[Not@FreeQ[howMany,Automatic],
        howMany=MapIndexed[#1/.Automatic\[Rule]
                  cyclicPart[automaticHowMany,#2]&,howMany]];
      howMany];



cyclicPart[obj_/;Length[obj]\[Equal]0,_]=obj;
cyclicPart[obj_,i_Integer]:=obj[[Mod[i,Length[obj],1]]];
cyclicPart[obj_,{i_Integer}]:=cyclicPart[obj,i];

SetAttributes[OrientedPlot,HoldAll]

Options[OrientedPlot]=
    Join[{Oriented\[Rule]True,HowManyArrows \[Rule] Automatic,
        ArrowPositions\[Rule]Automatic,ReverseOrientation\[Rule]False,
        Graphics`Arrow`HeadScaling\[Rule]Automatic,
        Graphics`Arrow`HeadLength\[Rule]1/20,ArrowShaftLength\[Rule]Automatic,
        ArrowsAcrossSubdivisions\[Rule]True,ArrowDensity\[Rule]1},
      Options[Plot],
      DeleteCases[
        Options[Arrow],(Graphics`Arrow`HeadScaling|
              Graphics`Arrow`HeadLength)\[Rule]_]];

OrientedPlot[f_,it_List,opts___?OptionQ]:=
    Module[{howMany,pos,revQ,c,referenceDimension},
      {howMany,arrowDensityParameter,pos,revQ,
          arwShftLngth}={HowManyArrows,ArrowDensity,ArrowPositions,
              ReverseOrientation,ArrowShaftLength}/.{opts}/.Options[
            OrientedPlot];
      If[NumericQ[pos],pos={{pos}}];
      If[pos===Automatic,pos={Automatic}];
      If[MatchQ[pos,{x__}/;Element[{x},Reals]],pos={pos}];
      If[Length[revQ]===0,revQ={revQ}];
      c=DrawGraphics`DrawingPaper`Draw[f,it,
          Evaluate[FilterOptions[Plot,opts]]];
      referenceDimension=maxLineExcursion[c];
      howMany=
        sortOutHowManyArrows[c,howMany,referenceDimension,
          arrowDensityParameter];
      arwShftLngth=
        If[TrueQ[arwShftLngth\[GreaterEqual]0],arwShftLngth,
          referenceDimension*Graphics`Arrow`HeadLength/.{opts}/.Options[
              OrientedPlot]];
      DrawGraphics`DrawingPaper`Draw2D[{c,
          MapIndexed[#1/.Line[pts_List]\[RuleDelayed]
                  insertArrows[pts,
                    
                    normalizedArrowPositions[cyclicPart[pos,#2],
                      cyclicPart[howMany,#2]],
                    ReverseOrientation\[Rule]TrueQ[cyclicPart[revQ,#2]],
                    ArrowShaftLength\[Rule]arwShftLngth,opts]&,
            c]},
        FilterOptions[Graphics,opts,Options[Plot]]]];



SetAttributes[OrientedParametricPlot,HoldAll]

Options[OrientedParametricPlot]=
    Join[{Oriented\[Rule]True,HowManyArrows\[Rule]Automatic,
        ArrowPositions\[Rule]Automatic,ReverseOrientation\[Rule]False,
        Graphics`Arrow`HeadScaling\[Rule]Automatic,
        Graphics`Arrow`HeadLength\[Rule]1/20,ArrowShaftLength\[Rule]Automatic,
        ArrowsAcrossSubdivisions\[Rule]True,ArrowDensity\[Rule]1},
      Options[ParametricPlot],
      DeleteCases[
        Options[Arrow],(Graphics`Arrow`HeadScaling|
              Graphics`Arrow`HeadLength)\[Rule]_]];

OrientedParametricPlot[f_,it_List,opts___?OptionQ]:=
    Module[{howMany,pos,revQ,c,referenceDimension,arwShftLngth},
      {howMany,arrowDensityParameter,pos,
          revQ}={HowManyArrows,ArrowDensity,ArrowPositions,
              ReverseOrientation}/.{opts}/.Options[OrientedParametricPlot];
      If[NumericQ[pos],pos={{pos}}];
      If[pos===Automatic,pos={Automatic}];
      If[MatchQ[pos,{x__}/;Element[{x},Reals]],pos={pos}];
      If[Length[revQ]===0,revQ={revQ}];
      c=DrawGraphics`DrawingPaper`ParametricDraw[f,it,
          Evaluate[FilterOptions[ParametricPlot,opts]]];
      referenceDimension=maxLineExcursion[c];
      howMany=
        sortOutHowManyArrows[c,howMany,referenceDimension,
          arrowDensityParameter];
      arwShftLngth=
        If[TrueQ[arwShftLngth\[GreaterEqual]0],arwShftLngth,
          referenceDimension*Graphics`Arrow`HeadLength/.{opts}/.Options[
              OrientedPlot]];
      DrawGraphics`DrawingPaper`Draw2D[{c,
          MapIndexed[#1/.Line[pts_List]\[RuleDelayed]
                  insertArrows[pts,
                    
                    normalizedArrowPositions[cyclicPart[pos,#2],
                      cyclicPart[howMany,#2]],
                    ReverseOrientation\[Rule]TrueQ[cyclicPart[revQ,#2]],
                    ArrowShaftLength\[Rule]arwShftLngth,opts]&,
            c]},
        FilterOptions[Graphics,opts,Options[ParametricPlot],
          DisplayFunction\[Rule]$DisplayFunction]]];



SetAttributes[OrientedParametricPlot3D,HoldAll]

Options[OrientedParametricPlot3D]=
    Join[{Oriented\[Rule]True,HowManyArrows\[Rule]Automatic,
        ArrowPositions\[Rule]Automatic,ReverseOrientation\[Rule]False,
        DrawGraphics`DrawingArrows`HeadScaling3D\[Rule]Automatic,
        DrawGraphics`DrawingArrows`HeadLength3D\[Rule]1/10,
        Arrow3DColor\[Rule]Automatic,ContourStyle\[Rule]Automatic,
        PlotStyle\[Rule]Automatic,ArrowsAcrossSubdivisions\[Rule]True,
        ArrowDensity\[Rule]1},
      Options[insertArrows],
      DeleteCases[Options[DrawGraphics`DrawingArrows`Arrow3D],
        DrawGraphics`DrawingArrows`HeadScaling3D\[Rule]_],
      Options[ParametricPlot3D]];

joinChain[obj_]:=obj//.
    {{primitive___,Line[{a__,b_}],Line[{b_,c__}],
          d___}\[RuleDelayed]{primitive,Line[{a,b,c}],
          d},{primitives0___,{primitives1___,Line[{a__,b_}]},{primitives2___,
            Line[{b_,c__}]},
          d___}\[RuleDelayed]{primitives0,{primitives1,Line[{a,b,c}]},d}}

makeStandardStyle[sty_]:=Which[
      sty===None,{{None}},
      sty===Automatic,{Automatic},
      sty==={},{{}},
      sty==={{}},{Automatic},
      Head[sty]=!=List,{{sty}},
      MatchQ[sty,{___,prim_/;Not[Head[prim]===List],___}],{sty},
      True,sty];

OrientedParametricPlot3D[f_,it_List,opts___?OptionQ]:=
    Module[{howMany,pos,revQ,arw3Dcolor,pltStyle,pltStyle2,c,cStyled,
        joinedLine,hdscl3D},
      {ortdQ,howMany,arrowDensityParameter,pos,revQ,arw3Dcolor,
          pltStyle}={OrientedCurve,HowManyArrows,ArrowDensity,ArrowPositions,
              ReverseOrientation,Arrow3DColor,PlotStyle}/.{opts}/.Options[
            OrientedParametricPlot3D];
      If[Not@TrueQ[ortdQ],howMany=0];
      If[NumericQ[pos],pos={{pos}}];
      If[pos===Automatic,pos={Automatic}];
      If[MatchQ[pos,{x__}/;Element[{x},Reals]],pos={pos}];
      If[Length[revQ]===0,revQ={revQ}];
      arw3Dcolor=makeStandardStyle[arw3Dcolor];
      pltStyle=makeStandardStyle[pltStyle];
      pltStyle2=makeStandardStyle[pltStyle]/.Automatic\[Rule]{};
      c=DrawGraphics`ParametricDrawing3D`ParametricDraw3D[f,it,
          Evaluate[FilterOptions[ParametricPlot3D,opts]]];
      cStyled=If[MatchQ[c,{__Line}],Join[pltStyle2[[1]],c],
          
          Replace[Transpose[{Table[cyclicPart[pltStyle2,i],{i,Length[c]}],
                c}],{{x___},y_}\[RuleDelayed]{x,y},{1}]];
      joinedLine=c//joinChain;
      referenceDimension=maxLineExcursion[joinedLine];
      howMany=
        sortOutHowManyArrows[joinedLine,howMany,referenceDimension,
          arrowDensityParameter];
      hdscl3D=
        automaticHeadScaling3D[joinedLine,opts,
          Sequence@@Options[OrientedParametricPlot3D]];
      DrawGraphics`DrawingCube`Draw3DItems[{cStyled,
          MapIndexed[#1/.Line[pts_List]\[RuleDelayed]
                  insertArrows[pts,
                    
                    normalizedArrowPositions[cyclicPart[pos,#2],
                      cyclicPart[howMany,#2]],
                    ReverseOrientation\[Rule]TrueQ[cyclicPart[revQ,#2]],
                    Arrow3DColor\[Rule]cyclicPart[arw3Dcolor,#2],
                    PlotStyle\[Rule]cyclicPart[pltStyle,#2],
                    hdscl3D,opts,
                    FilterOptions[DrawGraphics`DrawingArrows`Arrow3D,
                      Options[OrientedParametricPlot3D]]]&,
            joinedLine]},
        FilterOptions[Graphics3D,opts,Options[ParametricPlot3D],
          DisplayFunction\[Rule]$DisplayFunction]]];







toSplitQ[n_Integer/;n<3,pt0_List/;NumericQ[pt0[[1]]],pt1_List]/;
      MatrixQ[{pt0,pt1}]:=
    Module[{coord=Transpose[{pt0,pt1}][[n]],med1,med2},
      {med1,med2}={Floor[Min[#]]+1,Ceiling[Max[#]]-1}&[coord];
      {med1\[LessEqual]med2,
        If[OrderedQ[coord],Identity,Reverse][Range[med1,med2]]}];



makeSplit[n_Integer/;n<3][{pt0_List/;NumericQ[pt0[[1]]],pt1_List}]:=
    Module[{},
      {answer,divisions}=toSplitQ[n,pt0,pt1];
      If[answer,
        Join[{pt0},
          t*pt1+(1-t)*pt0/.Map[Solve[(t*pt1+(1-t)*pt0)[[n]]\[Equal]#,t][[1]]&,
              divisions],{pt1}],{pt0,pt1}]];



toSplitQ[3,pt0_List,pt1_List]:=Module[{v,c},
    v=Floor[Map[Min,Transpose[{pt0,pt1}]]];
    c={pt0-v,pt1-v};
    {Subtract@@c[[1]]*Subtract@@c[[2]]<0,c}]



makeSplit[3][{pt0_List/;NumericQ[pt0[[1]]],pt1_List}]:=Module[{answer,c0,c1},
      {answer,{c0,c1}}=toSplitQ[3,pt0,pt1];
      If[answer,
        Join[{pt0},t*pt1+(1-t)pt0/.Solve[Equal@@(t*c1+(1-t)c0),t],{pt1}],{pt0,
          pt1}]];



divideLine[ptsList_List]:=
    Fold[Flatten[Map[makeSplit[#2],Partition[#1,2,1]],1]&,
        ptsList,{1,2,3}]//.{a___,b_List,b_,c___}\[RuleDelayed]{a,b,c};





weight[pt_List/;NumericQ[pt[[1]]]]:=Module[{vert,loc,belowDiagQ},
      vert=Floor[pt];
      loc=pt-vert;
      belowDiagQ=(Subtract@@loc\[GreaterEqual]0);
      Map[Flatten,
        Cases[{{vert,w00},{vert+{1,0},w10},{vert+{1,1},w11},{vert+{0,1},
                  w01}}/.Solve[
                  Thread[loc\[Equal]
                        w00{0,0}+If[belowDiagQ,w10{1,0},w01{0,1}]+w11{1,1}]~
                    Join~{w00+If[belowDiagQ,w10,w01]+w11\[Equal]1},{w00,
                    If[belowDiagQ,w10,w01],w11}][[1]]/.{w10\[Rule]0,
              w01\[Rule]0},{_,w_/;w=!=0}]]];











normalizeCoordinates[pt_List/;NumericQ[pt[[1]]],xMin_,stepX_,yMin_,stepY_]:=
    Rationalize[(pt-{xMin,yMin})/{stepX,stepY},.00001];



originalCoordinates[nrmPt_List/;NumericQ[nrmPt[[1]]],xMin_,stepX_,yMin_,
      stepY_]:=nrmPt*{stepX,stepY}+{xMin,yMin};



SetAttributes[basicCurvePoints,HoldAll];

basicCurvePoints[{gu_,gv_},{t_,tMin_,tMax_},optsC___?OptionQ]:=
    Transpose[
        Drop[Transpose[
            ParametricPlot3D[{gu,gv,0},{t,tMin,tMax},
                  Evaluate[FilterOptions[ParametricPlot3D,optsC]],
                  PlotPoints\[Rule]15,
                  DisplayFunction\[Rule]
                    Identity][[1]]/.Line[{a__}]\[RuleDelayed]
                Sequence@@{a}],-1]]//.{x___,y_List,y_,z___}\[RuleDelayed]{x,y,
          z};





SetAttributes[PlotCurveOnSurface3D,HoldAll];



PlotCurveOnSurface3D[{f_/;Not[MatchQ[f,{__List}]],{u_Symbol,uMin_,
          uMax_},{v_Symbol,vMin_,vMax_},optsS1___?OptionQ,Oriented\[Rule]a_,
        optsS2___?OptionQ,Oriented\[Rule]_,optsS3___?OptionQ},
      curves:(({_,{_Symbol,_,_},{_Symbol,_,_},___?
                    OptionQ}|{{_,_},{_Symbol,_,_},___?OptionQ})...),
      optsGen___?OptionQ]:=
    PlotCurveOnSurface3D[{f,{u,uMin,uMax},{v,vMin,vMax},optsS1,
        Oriented\[Rule]a,optsS2,optsS3},curves,optsGen];

PlotCurveOnSurface3D[{f_/;Not[MatchQ[f,{__List}]],{u_Symbol,uMin_,
          uMax_},{v_Symbol,vMin_,vMax_},optsS1___?OptionQ,
        Oriented\[Rule](a_/;Not[TrueQ[a]]),optsS2___?OptionQ,Oriented\[Rule]_,
        optsS3___?OptionQ},
      curves:(({_,{_Symbol,_,_},{_Symbol,_,_},___?
                    OptionQ}|{{_,_},{_Symbol,_,_},___?OptionQ})...),
      optsGen___?OptionQ]:=
    PlotCurveOnSurface3D[{f,{u,uMin,uMax},{v,vMin,vMax},optsS1,optsS2,optsS3},
      curves,optsGen];





PlotCurveOnSurface3D[{f_/;Not[MatchQ[f,{__List}]],{u_Symbol,uMin_,
          uMax_},{v_Symbol,vMin_,vMax_},
        optsS___?OptionQ/;Not[True===(Oriented/.{optsS})]},
      curves:(({_,{_Symbol,_,_},{_Symbol,_,_},___?
                    OptionQ}|{{_,_},{_Symbol,_,_},___?OptionQ})...),
      optsGen___?OptionQ]:=
    Module[{parametric2DCurves,contour2DCurves,raw2DContours,
        basic2DContoursAndStyles,howManyContourArrows,basic2DContours,
        contoursStyles,basic2DParametricCurves,basic2Dcurves,xMin,xMax,yMin,
        yMax,dr,pdr,testSurface,n1,n2,stepX,stepY,gridInfo,
        normalizedbasic2Dcurves,curveXMin,curveXMax,curveYMin,curveYMax,
        subdividedCur,weightsList,fCoordinates,verticesData,weightedCoord,
        cur3D,parametricCur3D,contourCur3D,parametric2DCurveOptions,
        statedHowManyParametricArrows,referenceDimension,
        arrowDensityParameter,howManyParametricArrows,parametricCurveOpts,
        contourCurveOpts,curveOpts,parametricStyles,sty,adaptedCurvesWithOpts,
        srfVertices,plg,srface,srfSty,sr,hdscl3D,howMany,pos},
      parametric2DCurves=Cases[{curves},{{_,_},{_Symbol,_,_},___?OptionQ}];
      contour2DCurves=
        Cases[{curves},{_,{_Symbol,_,_},{_Symbol,_,_},___?OptionQ}];
      raw2DContours=
        Apply[DrawGraphics`DrawingPaper`ContourDraw,contour2DCurves,1];
      basic2DContoursAndStyles=
        Cases[raw2DContours,{___,{_Line,___}}|{__,_Line,___},{1,Infinity}];
      howManyContourArrows=
        Map[Count[#,_Arrow,{1,Infinity}]&,basic2DContoursAndStyles];
      basic2DContours=
        Cases[basic2DContoursAndStyles,
          Line[pts_]\[RuleDelayed]pts,{1,Infinity}];
      contoursStyles=
        basic2DContoursAndStyles/.{_Line,___}\[RuleDelayed]
              Sequence@@{}/.Line[_]\[RuleDelayed]Sequence@@{};
      basic2DParametricCurves=Apply[basicCurvePoints,parametric2DCurves,1];
      basic2Dcurves=Join[basic2DContours,basic2DParametricCurves];
      {xMin,xMax,yMin,yMax}=
        Rationalize[Evaluate[{uMin,uMax,vMin,vMax}],1/10^6];
      dr=DrawGraphics`DrawingCube`Draw3D;
      pdr=DrawGraphics`ParametricDrawing3D`ParametricDraw3D;
      testSurface=
        If[MatchQ[f,{_,_,_,___}],
          pdr[{x,y,0},{x,0,1},{y,2,3},
            Evaluate@FilterOptions[ParametricPlot3D,optsS,optsGen]],
          
          dr[0,{x,0,1},{y,2,3},
              Evaluate@FilterOptions[Plot3D,optsS,optsGen]]/.Polygon[
                pts_]\[RuleDelayed]Polygon[RotateLeft[pts]]];
      n1=1+Count[testSurface,Polygon[{{_,2.,_},__}],{1,Infinity}];
      n2=1+Count[testSurface,Polygon[{{0.,__},__}],{1,Infinity}];
      {stepX,stepY}=({xMax,yMax}-{xMin,yMin})/({n1,n2}-1);
      gridInfo={xMin,stepX,yMin,stepY};
      normalizedbasic2Dcurves=
        Map[normalizeCoordinates[#,Sequence@@gridInfo]&,basic2Dcurves,{2}];
      {{curveXMin,curveXMax},{curveYMin,curveYMax}}=
        Map[{Min[Floor[#]],Max[Ceiling[#]]}&,
          Transpose[
            Flatten[normalizedbasic2Dcurves,1]~
              Join~{{xMin,yMin},{xMax,yMax}}]];
      subdividedCur=Map[divideLine,normalizedbasic2Dcurves];
      weightsList=Map[weight,subdividedCur,{2}];
      fCoordinates=
        Which[Head[Evaluate[f]]=!=List,{u,v,f}/.Thread[{u,v}\[Rule]#]&,
          MatchQ[f,{_,_,_,___}],Take[f/.Thread[{u,v}\[Rule]#],3]&,
          MatchQ[f,{_,_}],{u,v,First[f]}/.Thread[{u,v}\[Rule]#]&];
      verticesData=Map[fCoordinates,
            
            N@Table[{x,y},{y,yMin+curveYMin*stepY,yMin+curveYMax*stepY,
                  stepY},{x,xMin+curveXMin*stepX,xMin+curveXMax*stepX,
                  stepX}],{2}]//(Rationalize[#,1/10^6]&);
      weightedCoord=
        Apply[#3*verticesData[[#2-curveYMin+1,#1-curveXMin+1]]&,
          weightsList,{3}];
      cur3D=Map[Line[Apply[Plus,#,1]]&,weightedCoord];
      parametricCur3D=Take[cur3D,-Length[basic2DParametricCurves]];
      contourCur3D=Take[cur3D,Length[basic2DContoursAndStyles]];
      parametric2DCurveOptions=Map[Drop[#,2]&,parametric2DCurves];
      statedHowManyParametricArrows=
        HowManyArrows/.parametric2DCurveOptions/.Options[
            OrientedParametricPlot3D];
      referenceDimension=maxLineExcursion[cur3D];
      arrowDensityParameter=
        ArrowDensity/.{optsGen}/.Options[OrientedParametricPlot3D];
      howManyParametricArrows=
        sortOutHowManyArrows[parametricCur3D,statedHowManyParametricArrows,
          referenceDimension,arrowDensityParameter];
      parametricCurveOpts=
        Apply[Prepend,
          Transpose[{parametric2DCurveOptions,
              Thread[HowManyArrows\[Rule]howManyParametricArrows]}],1];
      contourCurveOpts=
        Map[List,
            Thread[HowManyArrows\[Rule]howManyContourArrows]]/.{HowManyArrows\
\[Rule]n_?Positive}\[RuleDelayed]{HowManyArrows\[Rule]n,Oriented\[Rule]True};
      {contoursStyles,contourCurveOpts}=
        If[contoursStyles==={},{{},{}},
          Transpose[
            Transpose[{contoursStyles,
                  contourCurveOpts}]/.{{a___,col:colorSpecPattern,
                    c___},{d___}}\[RuleDelayed]{{a,col,c},{d,
                    Arrow3DColor\[Rule]col}}]];
      curveOpts=Join[contourCurveOpts,parametricCurveOpts];
      parametricStyles=
        If[parametric2DCurves==={},{},
          Map[Flatten[#,
                2]&,{PlotStyle}/.parametricCurveOpts/.{Automatic\[Rule]{},
                PlotStyle\[Rule]{}}]];
      sty=Join[contoursStyles,parametricStyles];
      cur3D=Map[Flatten[#,1]&,Transpose[{sty,cur3D}]];
      adaptedCurvesWithOpts=Transpose[{cur3D,curveOpts}];
      srfVertices=
        Map[fCoordinates,
            N@Table[{x,y},{y,yMin,yMax,stepY},{x,xMin,xMax,
                  stepX}],{2}]//(Rationalize[#,1/10^6]&);
      plg[i_,j_]:=
        Polygon[Apply[srfVertices[[##]]&,
            Map[{i,j}+#&,{{0,0},{0,1},{1,1},{1,0}}],1]];
      srface=Flatten@Table[plg[i,j],{i,n2-1},{j,n1-1}];
      Which[MatchQ[f,{_,_,_,_}],
        srfSty=Map[Drop[#,-1]&,
            pdr[f,{u,uMin,uMax},{v,vMin,vMax},PlotPoints\[Rule]{n1,n2}]];
        srface=Map[Flatten[#,1]&,Transpose[{srfSty,srface}]],
        Or[Head[f]=!=List,Length[f]\[Equal]2],
        sr=
          dr[f,{u,uMin,uMax},{v,vMin,vMax},PlotPoints\[Rule]{n1,n2},
              Evaluate[
                FilterOptions[Plot3D,
                  optsS]]]/._Polygon\[RuleDelayed]Sequence@@{};
        srfSty=
          Which[MatchQ[sr,{__,{__}}],Map[Join[Drop[sr,-1],{#}]&,Last[sr]],
            MatchQ[sr,{__,{}}],Table[Drop[sr,-1],{(n1-1)(n2-1)}],
            MatchQ[sr,{__}],Map[List,sr],
            MatchQ[sr,{}],Table[{},{(n1-1)(n2-1)}]
            ];
        srface=Map[Flatten[#,1]&,Transpose[{srfSty,srface}]]];
      hdscl3D=
        automaticHeadScaling3D[cur3D//N,optsGen,
          Sequence@@Options[OrientedParametricPlot3D]];
      Show[
        Graphics3D[{{EdgeForm[],srface},
            adaptedCurvesWithOpts/.{{sty___,
                    Line[pts_List]},{opt___}}\[RuleDelayed]({howMany,
                      pos}={HowManyArrows,ArrowPositions}/.{opt,
                          optsGen}/.Options[OrientedParametricPlot3D];
                  If[Not@TrueQ[OrientedCurve/.{opt}],pos={}];
                  {If[MemberQ[{None,{None}},PlotStyle/.{opt}],Sequence@@{},
                      Sequence@@{sty,Line[pts]}],
                    insertArrows[pts,normalizedArrowPositions[pos,howMany],
                      opt,optsGen,hdscl3D,
                      Sequence@@Options[OrientedParametricPlot3D]]})}],
        FilterOptions[Graphics3D,optsGen,
          If[MatchQ[f,{_,_}],Lighting\[Rule]False,{}],
          Options[OrientedParametricPlot3D]]]];



PlotCurveOnSurface3D[{f_/;Not[MatchQ[f,{__List}]],{u_Symbol,uMin_,
          uMax_},{v_Symbol,vMin_,vMax_},optsS1___?OptionQ,Oriented\[Rule]True,
        optsS2___?OptionQ},
      curves:(({_,{_Symbol,_,_},{_Symbol,_,_},___?
                    OptionQ}|{{_,_},{_Symbol,_,_},___?OptionQ})...),
      optsGen___?OptionQ]:=
    Module[{howMany,pos,revQ,hdlngh3D,cntrstyle,arwColor,bdrOpts},
      {howMany,pos,revQ,hdlngh3D,cntrstyle,
          arwColor}={HowManyArrows,ArrowPositions,ReverseOrientation,
                DrawGraphics`DrawingArrows`HeadLength3D,ContourStyle,
                Arrow3DColor}/.{optsS1,optsS2,optsGen}/.Options[
              OrientedParametricPlot]/.Options[OrientedParametricPlot3D];
      If[Head[howMany]=!=List,howMany={howMany}];
      If[MatchQ[pos,{__?NumericQ}|Automatic],pos={pos}];
      If[Length[revQ]===0,revQ={revQ}];
      cntrstyle=makeStandardStyle[cntrstyle];
      arwColor=makeStandardStyle[arwColor];
      bdrOpts[i_]:={HowManyArrows\[Rule]cyclicPart[howMany,i],
          ArrowPositions\[Rule]cyclicPart[pos,i],
          ReverseOrientation\[Rule]cyclicPart[revQ,i],
          PlotStyle\[Rule]cyclicPart[cntrstyle,i],
          Arrow3DColor\[Rule]cyclicPart[arwColor,i],
          DrawGraphics`DrawingArrows`HeadLength3D\[Rule]hdlngh3D};
      PlotCurveOnSurface3D[{f,{u,uMin,uMax},{v,vMin,vMax},optsS1,optsS2},
        Evaluate[{{u,vMin},{u,uMin,uMax},Oriented\[Rule]True,
            PlotPoints\[Rule]2,Sequence@@bdrOpts[1]}],
        Evaluate[{{uMax,v},{v,vMin,vMax},Oriented\[Rule]True,
            PlotPoints\[Rule]2,Sequence@@bdrOpts[2]}],
        Evaluate[{{uMax-u,vMax},{u,0,uMax-uMin},Oriented\[Rule]True,
            PlotPoints\[Rule]2,Sequence@@bdrOpts[3]}],
        Evaluate[{{uMin,vMax-v},{v,0,vMax-vMin},Oriented\[Rule]True,
            PlotPoints\[Rule]2,Sequence@@bdrOpts[4]}],
        curves,optsGen]];

SetAttributes[DrawCurveOnSurface3D,HoldAll];

DrawCurveOnSurface3D[
      surf:{f_/;Not[MatchQ[f,{__List}]],{u_Symbol,uMin_,uMax_},{v_Symbol,
            vMin_,vMax_},optsS___?OptionQ},
      curves:(({_,{_Symbol,_,_},{_Symbol,_,_},___?
                    OptionQ}|{{_,_},{_Symbol,_,_},___?OptionQ})...),
      optsGen___?OptionQ]:=Block[{$DisplayFunction=Identity},
      PlotCurveOnSurface3D[surf,curves,optsGen][[1]]];



OrientedParametricPlot3D[f_,it1_List,it2_List,opts___?OptionQ]:=
    PlotCurveOnSurface3D[{f,it1,it2,Oriented\[Rule]True,opts},
      Evaluate@FilterOptions[Graphics3D,opts]];



SetAttributes[OrientedPlot3D,HoldAll]

OrientedPlot3D[f_,it1_List,it2_List,opts___?OptionQ]:=
    PlotCurveOnSurface3D[{f,it1,it2,Oriented\[Rule]True,opts},
      Evaluate@FilterOptions[Graphics3D,opts]];



Unprotect[Plot];
Plot[f_,x_,opts1___?OptionQ,Oriented\[Rule]a_,opts2___?OptionQ,
    Oriented\[Rule]_,opts3___?OptionQ]:=
  Plot[f,x,opts1,Oriented\[Rule]a,opts2,opts3];
Plot[f_,x_,opts1___?OptionQ,Oriented\[Rule]True,opts2___?OptionQ]:=
  OrientedPlot[f,x,opts1,opts2];
Plot[f_,x_,opts1___?OptionQ,Oriented\[Rule](smthng_/;Not[TrueQ[smthng]]),
      opts2___?OptionQ]:=Plot[f,x,opts1,opts2];
Protect[Plot];

Unprotect[ParametricPlot];
ParametricPlot[f_,x_,opts1___?OptionQ,Oriented\[Rule]a_,opts2___?OptionQ,
      Oriented\[Rule]_,opts3___?OptionQ]:=
    ParametricPlot[f,x,opts1,Oriented\[Rule]a,opts2,opts3];
ParametricPlot[f_,x_,opts1___?OptionQ,Oriented\[Rule]True,opts2___?OptionQ]:=
    OrientedParametricPlot[f,x,opts1,opts2];
ParametricPlot[f_,x_,opts1___?OptionQ,
      Oriented\[Rule](smthng_/;Not[TrueQ[smthng]]),opts2___?OptionQ]:=
    ParametricPlot[f,x,opts1,opts2];
Protect[ParametricPlot];

Unprotect[Plot3D];
Plot3D[f_,x_List,y_List,opts1___?OptionQ,Oriented\[Rule]a_,opts2___?OptionQ,
      Oriented\[Rule]_,opts3___?OptionQ]:=
    Plot3D[f,x,y,opts1,Oriented\[Rule]a,opts2,opts3];
Plot3D[f_,x_List,y_List,opts1___?OptionQ,Oriented\[Rule]True,
      opts2___?OptionQ]:=OrientedPlot3D[f,x,y,opts1,opts2];
Plot3D[f_,x_List,y_List,opts1___?OptionQ,
      Oriented\[Rule](smthng_/;Not[TrueQ[smthng]]),opts2___?OptionQ]:=
    Plot3D[f,x,y,opts1,opts2];
Protect[Plot3D];

Unprotect[DrawGraphics`DrawingCube`Draw3D];
DrawGraphics`DrawingCube`Draw3D[data1__,Oriented\[Rule]True,data2___]:=
  First[Plot3D[data1,Oriented\[Rule]True,data2,
      DisplayFunction\[Rule]Identity]];
Protect[DrawGraphics`DrawingCube`Draw3D];

Unprotect[ParametricPlot3D];
ParametricPlot3D[f_,x_,opts1___?OptionQ,Oriented\[Rule]a_,opts2___?OptionQ,
      Oriented\[Rule]_,opts3___?OptionQ]:=
    ParametricPlot3D[f,x,opts1,Oriented\[Rule]a,opts2,opts3];
ParametricPlot3D[f_,x_List,opts1___?OptionQ,Oriented\[Rule]True,
      opts2___?OptionQ]:=OrientedParametricPlot3D[f,x,opts1,opts2];
ParametricPlot3D[f_,x_List,opts1___?OptionQ,
      Oriented\[Rule](smthng_/;Not[TrueQ[smthng]]),opts2___?OptionQ]:=
    ParametricPlot3D[f,x,opts1,opts2];

ParametricPlot3D[f_,x_,y_List,opts1___?OptionQ,Oriented\[Rule]a_,
      opts2___?OptionQ,Oriented\[Rule]_,opts3___?OptionQ]:=
    ParametricPlot3D[f,x,y,opts1,Oriented\[Rule]a,opts2,opts3];
ParametricPlot3D[f_,x_List,y_List,opts1___?OptionQ,Oriented\[Rule]True,
      opts2___?OptionQ]:=OrientedParametricPlot3D[f,x,y,opts1,opts2];
ParametricPlot3D[f_,x_List,y_List,opts1___?OptionQ,
      Oriented\[Rule](smthng_/;Not[TrueQ[smthng]]),opts2___?OptionQ]:=
    ParametricPlot3D[f,x,y,opts1,opts2];
Protect[ParametricPlot3D];





crossingQ[{xMin_,xMax_},{yMin_,yMax_}][{{x1_?NumericQ,y1_},{x2_?NumericQ,
          y2_}}]:=Or[x1<xMin<x2,x2<xMin<x1,x1<xMax<x2,x2<xMax<x1,y1<yMin<y2,
      y2<yMin<y1,y1<yMax<y2,y2<yMax<y1];



crossingQ[{xMin_,xMax_},{yMin_,yMax_},{zMin_,zMax_}][{{x1_?NumericQ,y1_,
          z1_},{x2_?NumericQ,y2_,z2_}}]:=
    Or[x1<xMin<x2,x2<xMin<x1,x1<xMax<x2,x2<xMax<x1,y1<yMin<y2,y2<yMin<y1,
      y1<yMax<y2,y2<yMax<y1,z1<zMin<z2,z2<zMin<z1,z1<zMax<z2,z2<zMax<z1];





addCrossingPoint[{pt1:{x1_?NumericQ,__},pt2:{x2_,__}},{_,xMax_},__]/;
      Or[x1<xMax<x2,x2<xMax<x1]:=
    {t*pt1+(1-t)pt2,pt2}/.t\[Rule]-((x2-xMax)/(x1-x2));



addCrossingPoint[{pt1:{x1_?NumericQ,__},pt2:{x2_,__}},{xMin_,_},__]/;
      Or[x1<xMin< x2,x2<xMin<x1]:=
    {t*pt1+(1-t)pt2,pt2}/.t\[Rule]-((x2-xMin)/(x1-x2));



addCrossingPoint[{pt1:{_,y1_?NumericQ,___},pt2:{_,y2_,___}},_,{_,yMax_},___]/;
      Or[y1<yMax<y2,y2<yMax<y1]:=
    {t*pt1+(1-t)pt2,pt2}/.t\[Rule]-((y2-yMax)/(y1-y2));



addCrossingPoint[{pt1:{_,y1_?NumericQ,___},pt2:{_,y2_,___}},_,{yMin_,_},___]/;
      Or[y1<yMin< y2,y2<yMin<y1]:=
    {t*pt1+(1-t)pt2,pt2}/.t\[Rule]-((y2-yMin)/(y1-y2));

addCrossingPoint[{pt1:{_,_,z1_?NumericQ},pt2:{_,_,z2_}},_,_,{_,zMax_}]/;
      Or[z1<zMax<z2,z2<zMax<z1]:=
    {t*pt1+(1-t)pt2,pt2}/.t\[Rule]-((z2-zMax)/(z1-z2));

addCrossingPoint[{pt1:{_,_,z1_?NumericQ},pt2:{_,_,z2_}},_,_,{zMin_,_}]/;
      Or[z1<zMin<z2,z2<zMin<z1]:=
    {t*pt1+(1-t)pt2,pt2}/.t\[Rule]-((z2-zMin)/(z1-z2));

addCrossingPoint[cplpts_,lts__]/;Not[crossingQ[lts][cplpts]]:={Last[cplpts]};





strictlyInsideQ[varRange__][pt_]:=
    And@@Less@@@Transpose@Insert[Transpose[{varRange}],pt,2];



weaklyInsideQ[varRange__][pt_]:=
    And@@LessEqual@@@Transpose@Insert[Transpose[{varRange}],pt,2];

weaklyOutsideQ[varRange__][pt_]:=Not[strictlyInsideQ[varRange][pt]];

strictlyOutsideQ[varRange__][pt_]:=Not[weaklyInsideQ[varRange][pt]];



clipAndPlaceArrows[gr_,lts__List,inversionCriterion_,
      arrowDensityParameter_?NonNegative,opts___?OptionQ]:=
    Module[{strOuts,wklIn,adjClosedPaths,provisional,subdivided,clipped,
        wrongDirectionQ,directedTraj,r},
      strOuts[a_]:=PatternTest[a,Evaluate[strictlyOutsideQ[lts]]];
      wklIn[a_]:=PatternTest[a,Evaluate[weaklyInsideQ[lts]]];
      adjClosedPaths=
        gr/.Line[{a_,b___,a_}]\[RuleDelayed]
                provisional[{a,b,a}]/.provisional[{a___,strOuts[b_],
                  c___}]\[RuleDelayed]provisional[{b,c,a}]/.provisional\[Rule]
            Line;
      subdivided=
        adjClosedPaths//.Line[pts_]\[RuleDelayed]
            Line[Join[{First[pts]},
                Flatten[Map[addCrossingPoint[#,lts]&,Partition[pts,2,1]],
                  1]]];
      tst=
        Or[And[strictlyOutsideQ[lts][#1],strictlyOutsideQ[lts][#2]],
            And[weaklyInsideQ[lts][#1],weaklyInsideQ[lts][#2]]]&;
      clipped=
        subdivided/.Line[pts_]\[RuleDelayed]
              Map[Line,Split[pts,tst]]/.{Line[{strOuts[__]}]\[RuleDelayed]
              Sequence@@{},Line[{a_}]\[RuleDelayed]Sequence@@{}};
      r[pts_]/;lineLength[pts]>$MachineEpsilon:=
        r[pts]=Ceiling[
            arrowDensityParameter*(lineLength[pts]/
                    Sqrt[Apply[Plus,Apply[Subtract,{lts},1]^2]]-1/15)];
      r[pts_]/;lineLength[pts]\[LessEqual]$MachineEpsilon:=1;
      arwShftLngth=
        ArrowShaftLength/.{opts}/.ArrowShaftLength\[Rule]Automatic;
      arwShftLngth=
        If[TrueQ[arwShftLngth\[GreaterEqual]0],arwShftLngth,
          maxLineExcursion[clipped]*
                Graphics`Arrow`HeadLength/.{opts}/.Options[HamiltonianPlot]];
      clipped/.Line[pts_List]\[RuleDelayed]
          Sequence@@{Line[If[TrueQ@inversionCriterion[pts],Reverse@pts,pts]],
              insertArrows[pts,normalizedArrowPositions[Automatic,r[pts]],
                ReverseOrientation\[Rule]inversionCriterion[pts],
                ArrowShaftLength\[Rule]arwShftLngth,opts]}];



Options[HamiltonianPlot]={ReverseOrientation\[Rule]False,
      ShowField\[Rule]False,ArrowDensity\[Rule]1,
      Graphics`Arrow`HeadScaling\[Rule]Automatic,
      Graphics`Arrow`HeadLength\[Rule]1/20,ArrowShaftLength\[Rule]Automatic,
      ArrowsAcrossSubdivisions\[Rule]True};

HamiltonianPlot[h_,{x_Symbol,xMin_,xMax_},{y_Symbol,yMin_,yMax_},
      opts___?OptionQ]:=
    Module[{levelData,showFieldQ,arwDnsty,revDirQ,approx,grad,a,b,sympMat,
        wrongDirectionQ,allTrajs,lateralMargin,topBottomMargin,fld},
      levelData=
        ContourPlot[h,{x,xMin,xMax},{y,yMin,yMax},
          DisplayFunction\[Rule]Identity,
          Evaluate[FilterOptions[ContourPlot,opts]],
          ContourShading\[Rule]False];
      {showFieldQ,arwDnsty,
          revDirQ}={ShowField,ArrowDensity,
              ReverseOrientation}/.{opts}/.Options[HamiltonianPlot];
      approx=
        ListInterpolation[
          Transpose[levelData[[1]]],{{xMin,xMax},{yMin,yMax}}];
      grad[{a_,b_}]:=
        Through[{Derivative[1,0][approx],Derivative[0,1][approx]}[a,b]];
      sympMat={{0,1},{-1,0}};
      wrongDirectionQ[
          pts_List]:=(If[TrueQ[revDirQ],-1,1]*
              byArcLength[pts]'[0].(sympMat.grad[First[pts]])<0);
      allTrajs=
        clipAndPlaceArrows[Graphics[levelData],{xMin,xMax},{yMin,yMax},
          wrongDirectionQ,arwDnsty,opts,Sequence@@Options[HamiltonianPlot]];
      {lateralMargin,topBottomMargin}={xMax-xMin,yMax-yMin}/40;
      fld:=
        PlotVectorField[
          sympMat.grad[{a,b}],{a,xMin+lateralMargin,xMax-lateralMargin},{b,
            yMin+topBottomMargin,yMax-topBottomMargin},
          DisplayFunction\[Rule]Identity];
      Show[{allTrajs,If[showFieldQ,fld,Sequence@@{}]},
        FilterOptions[Graphics,opts],DisplayFunction\[Rule]$DisplayFunction]];

Unprotect[ContourPlot];
ContourPlot[h_,{x_Symbol,xMin_,xMax_},{y_Symbol,yMin_,yMax_},opts1___?OptionQ,
      Oriented\[Rule]a_,opts2___?OptionQ,Oriented\[Rule]_,opts3___?OptionQ]:=
    ContourPlot[h,{x,xMin,xMax},{y,yMin,yMax},opts1,Oriented\[Rule]a,opts2,
      opts3];
ContourPlot[h_,{x_Symbol,xMin_,xMax_},{y_Symbol,yMin_,yMax_},opts1___?OptionQ,
      Oriented\[Rule]True,opts2___?OptionQ]:=
    HamiltonianPlot[h,{x,xMin,xMax},{y,yMin,yMax},opts1,opts2];
ContourPlot[h_,{x_Symbol,xMin_,xMax_},{y_Symbol,yMin_,yMax_},opts1___?OptionQ,
      Oriented\[Rule](smthg_/;Not[TrueQ[smthg]]),opts2___?OptionQ]:=
    ContourPlot[h,{x,xMin,xMax},{y,yMin,yMax},opts1,opts2];
Protect[ContourPlot];



Options[NDSolvePlot]={PlotStyle\[Rule]Automatic};



NDSolvePlot[eqs_,{x1_,x2_},{t_,tMin_,tMax_},opts___?OptionQ]:=
    Module[{solRule,sol,f,ortdQ},
      solRule=NDSolve[eqs,{x1,x2},{t,tMin,tMax},FilterOptions[NDSolve,opts]];
      sol={x1,x2}/.solRule[[1]];
      f=If[Head[sol[[1]]]===InterpolatingFunction,Through[sol[t]],sol];
      ortdQ=TrueQ[Oriented/.{opts}/.Oriented\[Rule]True];
      {solRule,
        ParametricPlot[Evaluate[f],{t,tMin,tMax},
          Evaluate[
            FilterOptions[If[ortdQ,OrientedParametricPlot,ParametricPlot],
              opts,Oriented\[Rule]True]]]}];



NDSolvePlot[eqs_,{x1_,x2_,x3_},{t_,tMin_,tMax_},opts___?OptionQ]:=
    Module[{solRule,sol,f,ortdQ},
      solRule=
        NDSolve[eqs,{x1,x2,x3},{t,tMin,tMax},FilterOptions[NDSolve,opts]];
      sol={x1,x2,x3}/.solRule[[1]];
      ortdQ=TrueQ[Oriented/.{opts}/.Oriented\[Rule]True];
      f=If[Head[sol[[1]]]===InterpolatingFunction,Through[sol[t]],sol];
      {solRule,
        OrientedParametricPlot3D[Evaluate[f],{t,tMin,tMax},opts,
          Oriented\[Rule]True]}];



NDSolvePlot[eqs_,x_/;Head[x]=!=List,{t_,tMin_,tMax_},opts___?OptionQ]:=
    Module[{solRule,sol,f},
      solRule=NDSolve[eqs,x,{t,tMin,tMax},FilterOptions[NDSolve,opts]];
      sol=x/.solRule[[1]];
      f=If[Head[sol]===InterpolatingFunction,sol[t],sol];
      ortdQ=TrueQ[Oriented/.{opts}/.Oriented\[Rule]False];
      {solRule,
        ParametricPlot[Evaluate[{t,f}],{t,tMin,tMax},
          Evaluate[
            FilterOptions[If[ortdQ,OrientedParametricPlot,ParametricPlot],
              opts]]]}];

NDSolvePlot[eqs_,{x_},{t_,tMin_,tMax_},opts___?OptionQ]:=
    NDSolvePlot[eqs,x,{t,tMin,tMax},opts];

NDSolveDraw[x__]:=
    Block[{$DisplayFunction=Identity,sol,plt},{sol,plt}=NDSolvePlot[x];
      {sol,First[plt]}];

Unprotect[NDSolve];

NDSolve[eqs_,x_/;Head[x]=!=List,{t_,tMin_,tMax_},opts1___?OptionQ,
      PlotSolution\[Rule]True,opts2___?OptionQ]:=
    NDSolvePlot[eqs,x,{t,tMin,tMax},opts1,opts2];
NDSolve[eqs_,x_List/;1\[LessEqual]Length[x]\[LessEqual]3,{t_,tMin_,tMax_},
      opts1___?OptionQ,PlotSolution\[Rule]True,opts2___?OptionQ]:=
    NDSolvePlot[eqs,x,{t,tMin,tMax},opts1,opts2];
NDSolve[eqs_,x_,t_List,opts1___?OptionQ,
      PlotSolution\[Rule]value/;Not@TrueQ[value],opts2___?OptionQ]:=
    NDSolve[eqs,x,t,opts1,opts2];

NDSolve[eqs_,x_/;Head[x]=!=List,{t_,tMin_,tMax_},opts1___?OptionQ,
      DrawSolution\[Rule]True,opts2___?OptionQ]:=
    NDSolveDraw[eqs,x,{t,tMin,tMax},opts1,opts2];
NDSolve[eqs_,x_List/;1\[LessEqual]Length[x]\[LessEqual]3,{t_,tMin_,tMax_},
      opts1___?OptionQ,DrawSolution\[Rule]True,opts2___?OptionQ]:=
    NDSolveDraw[eqs,x,{t,tMin,tMax},opts1,opts2];
NDSolve[eqs_,x_,t_List,opts1___?OptionQ,
      DrawSolution\[Rule]value/;Not@TrueQ[value],opts2___?OptionQ]:=
    NDSolve[eqs,x,t,opts1,opts2];

Protect[NDSolve];



Options[PhasePlot]={GridPoints\[Rule]5,InitialPoints\[Rule]Automatic,
      OrientedCurve\[Rule]True,Frame\[Rule]True, ArrowDensity\[Rule]1,
      ShowField\[Rule]False,Graphics`Arrow`HeadScaling\[Rule]Automatic,
      Graphics`Arrow`HeadLength\[Rule]1/20,
      DrawGraphics`DrawingArrows`HeadScaling3D\[Rule]Automatic,
      DrawGraphics`DrawingArrows`HeadLength3D\[Rule]1/20,
      PlotStyle\[Rule]Automatic,ColorFunctionScaling\[Rule]True,
      ShowListPlot\[Rule]False,ListPlotStyle\[Rule]PointSize[.02],
      Arrow3DColor\[Rule]Automatic};

PhasePlot::"BadPlotPoints"="Bad PlotPoints";

PhasePlot[{{xComponent_},{yComponent_}},
      {x_Symbol,xMin_?NumericQ,xMax_?NumericQ},
      {y_Symbol,yMin_?NumericQ,yMax_?NumericQ},
      {tMin_?NonPositive,tMax_?NonNegative},
      opts___?OptionQ]:=
    PhasePlot[{xComponent,yComponent},{x,xMin,xMax},{y,yMin,yMax},{tMin,tMax},
      opts];
PhasePlot[{{xComponent_},{yComponent_},{zComponent_}},
      {x_Symbol,xMin_?NumericQ,xMax_?NumericQ},
      {y_Symbol,yMin_?NumericQ,yMax_?NumericQ},
      {z_Symbol,zMin_?NumericQ,zMax_?NumericQ},
      {tMin_?NonPositive,tMax_?NonNegative},
      opts___?OptionQ]:=
    PhasePlot[{xComponent,yComponent,zComponent},{x,xMin,xMax},{y,yMin,
        yMax},{z,zMin,zMax},{tMin,tMax},opts];

PhasePlot[field_List/;Head[field[[1]]]=!=List,
        variableLimits:{_Symbol,_?NumericQ,_?NumericQ}../;
          And@@Map[Less@@Rest[#]&,{variableLimits}],{tMin_?NonPositive,
          tMax_?NonNegative},opts___?OptionQ]/;
      2\[LessEqual]Length[field]===Length[{variableLimits}]\[LessEqual]3:=
    Module[{dim,var,lmts,howManyPts,shwArrsQ,arwDnsty,colorSclng,arwColor,
        shwLstPlt,lstPltSty,margins,pts,intlPts,strtPts,eq,t,u,v,w,x0,sol,
        allSols,hdscl3D,allTrajs,gr},
      dim=Length[field];
      var={variableLimits}[[All,1]];
      lmts=Map[Rest,{variableLimits}];
      {howManyPts,intlPts,shwArrsQ,arwDnsty,sty,colorSclng,arwColor,shwLstPlt,
          lstPltSty}={GridPoints,InitialPoints,OrientedCurve,ArrowDensity,
              PlotStyle,ColorFunctionScaling,Arrow3DColor,ShowListPlot,
              ListPlotStyle}/.{opts}/.Options[PhasePlot];
      margins=-Subtract@@@lmts/40;
      pts=Which[
          
          MatchQ[howManyPts,
            l:{__Integer?(#\[GreaterEqual]2&)}/;Length[l]\[Equal]dim],
          howManyPts,
          MatchQ[howManyPts,_Integer?(#\[GreaterEqual]2&)],
          Table[howManyPts,{dim}],
          True,Message[PhasePlot::BadPlotPoints];Abort[]];
      strtPts=If[
          intlPts===Automatic,Flatten[Outer[List,
              
              Sequence@@(Apply[Range[#1,#2,(#2-#1)/(#3-1)]&,
                    Transpose[Append[Transpose[lmts]+{margins,-margins},pts]],
                    1])],dim-1],
          intlPts];
      scaledStrtPts:=
        Map[(#-lmts[[All,1]])/(lmts[[All,2]]-lmts[[All,1]])&,
            strtPts]/.x_?NumericQ\[RuleDelayed]Min[Max[x,0],1];
      Which[sty===Automatic,sty={{}},
        Or[Head[sty]===Function,dim===3&&MemberQ[{CMYColor,RGBColor},sty]],
        sty=Apply[Flatten[{sty[##]}]&,
            If[TrueQ@colorSclng,scaledStrtPts,strtPts],1],
        Not@MatchQ[sty,{__List}],sty={sty}];
      If[dim===3,
        Which[arwColor===Automatic,
          sty=sty/.(col:colorSpecPattern)\[RuleDelayed]
                Sequence@@{col,SurfaceColor[col]},
          Or[Head[arwColor]===Function,MemberQ[{CMYColor,RGBColor},arwColor]],
          arwColor=
            Apply[SurfaceColor[arwColor[##]]&,
              If[TrueQ@colorSclng,scaledStrtPts,strtPts],1],
          Not@MatchQ[arwColor,{__List}],arwColor={arwColor}]];
      If[arwColor=!=Automatic,
        arwColor=
          arwColor/.(col:colorSpecPattern)\[RuleDelayed]SurfaceColor[col]];
      Which[lstPltSty===Automatic,lstPltSty={{}},
        Or[Head[lstPltSty]===Function,
          dim===3&&MemberQ[{CMYColor,RGBColor},lstPltSty]],
        lstPltSty=lstPltSty@@@If[TrueQ@colorSclng,scaledStrtPts,strtPts],
        Not@MatchQ[lstPltSty,{__List}],lstPltSty={lstPltSty}];
      lstPlt:=
        MapIndexed[
            Flatten@{cyclicPart[sty,#2],cyclicPart[lstPltSty,#2],Point[#1]}&,
            strtPts]/.Automatic\[RuleDelayed]Sequence@@{};
      eq[x0_List,{i_Integer}]:={Flatten[{Thread[
                  Take[{u'[t],v'[t],w'[t]},dim]\[Equal]field]/.Thread[
                  var\[Rule]Take[{u[t],v[t],w[t]},dim]],
              Thread[Take[{u[0],v[0],w[0]},dim]\[Equal]x0]}],
          Take[{u,v,w},dim],{t,tMin,tMax},HowManyArrows\[Rule]0,
          DisplayFunction\[Rule]Identity,
          PlotStyle\[Rule]If[Or[dim===2,arwColor===Automatic],
              cyclicPart[sty,i],
              Flatten[{cyclicPart[sty,i],cyclicPart[arwColor,i]}]],opts};
      sol[x0_List,{i_Integer}]:=
        joinChain[
          Apply[NDSolvePlot,eq[x0,{i}]][[2,1]]/.{}\[Rule]Sequence@@{}];
      allSols=MapIndexed[sol,strtPts]/.Automatic\[RuleDelayed]Sequence@@{};
      hdscl3D=
        automaticHeadScaling3D[Line[lmts//Transpose],opts,
          Sequence@@Options[OrientedParametricPlot3D]];
      allTrajs=
        If[shwArrsQ,
          clipAndPlaceArrows[allSols,Sequence@@lmts,False&,arwDnsty,
            Arrow3DColor\[Rule]None,
            Sequence@@DeleteCases[{opts},PlotStyle\[Rule]_],hdscl3D,
            Sequence@@Options[PhasePlot]],allSols];
      gr=If[dim\[Equal]2,Graphics,Graphics3D];
      Show[{gr[
            If[dim\[Equal]2,allTrajs,{SurfaceColor[GrayLevel[0]],allTrajs}]],
          If[TrueQ@shwLstPlt,gr[lstPlt],Sequence@@{}]},FilterOptions[gr,opts],
        PlotRange\[Rule]lmts,FilterOptions[gr,Sequence@@Options[PhasePlot]]]];

PhaseDraw[field_List,
        variableLimits:{_Symbol,_?NumericQ,_?NumericQ}../;
          And@@Map[Less@@Rest[#]&,{variableLimits}],{tMin_?NonPositive,
          tMax_?NonNegative},opts___?OptionQ]/;
      2\[LessEqual]Length[field]===Length[{variableLimits}]\[LessEqual]3:=
    PhasePlot[field,variableLimits,{tMin,tMax},DisplayFunction\[Rule]Identity,
        opts][[1]];







admissibleMatrixQ::"notMatrix"="Not a 2 by 2 matrix";

admissibleMatrixQ::"nonNumeric"="Not a numeric matrix";

admissibleMatrixQ::"complex"="Complex matrix";

admissibleMatrixQ::"inexactMatrix"="Not an exact numeric matrix";



admissibleMatrixQ[mat_?MatrixQ]:=admissibleMatrixQ[mat]=And[
        If[MatrixQ[mat]&&Length[mat]===2&&TensorRank[mat]===2,True,
          Message[admissibleMatrixQ::"notMatrix"];False],
        If[And@@Map[NumericQ,Flatten[mat]],True,
          Message[admissibleMatrixQ::"nonNumeric"];False],
        If[And@@Map[FreeQ[Chop[N[#]],Complex]&,Flatten[mat]],True,
          Message[admissibleMatrixQ::"complex"];False],
        If[Precision[mat]===Infinity,True,
          Message[admissibleMatrixQ::"inexactMatrix"];False]];



diagonalQ[mat_?MatrixQ]:=Simplify[mat[[1,2]]]===0&&Simplify[mat[[2,1]]]===0;

nonNullQ[mat_]:=Apply[Or,Map[#=!=0&,Simplify[Flatten[{mat}]]]];

nullMatrixQ[mat_]:=Union[Flatten[Simplify[mat]]]==={0};





matrixTrace=If[$VersionNumber<4,(#[[1,1]]+#[[2,2]])&,Tr];



discriminant[mat_]:=Simplify[matrixTrace[mat]^2-4Det[mat]];



realCanonicalForm[mat_/;discriminant[mat]\[GreaterEqual]0]:=
    JordanDecomposition[m];

realCanonicalForm[mat_/;discriminant[mat]<0]:=
    Module[{complexSim,complexJordan,realSim},
      {complexSim,complexJordan}=JordanDecomposition[mat];
      realSim=Transpose[{Re[#],Im[#]}&[complexSim//Transpose//First]];
      {realSim,Inverse[realSim].mat.realSim}];





saddleQ[mat_?admissibleMatrixQ]:=discriminant[mat]>0&&Simplify[Det[mat]]<0;

nodeQ[mat_?admissibleMatrixQ]:=discriminant[mat]>0&&Simplify[Det[mat]]>0;

singularDistinctEigenvaluesQ[mat_?admissibleMatrixQ]:=
    discriminant[mat]>0&&Simplify[Det[mat]]===0;

improperNodeQ[mat_?admissibleMatrixQ]:=
    discriminant[mat]===0&&Simplify[matrixTrace[mat]]=!=0&&!diagonalQ[mat];

nonNullMultipleOfIdentity[mat_?admissibleMatrixQ]:=
    discriminant[mat]===0&&diagonalQ[mat]&&nonNullQ[mat];

nonNullNilpotentQ[mat_?admissibleMatrixQ]:=
    discriminant[mat]===0&&Simplify[matrixTrace[mat]]===0&&nonNullQ[mat];

centerQ[mat_?admissibleMatrixQ]:=
    discriminant[mat]<0&&Simplify[matrixTrace[mat]]===0;

spiralQ[mat_?admissibleMatrixQ]:=
    discriminant[mat]<0&&Simplify[matrixTrace[mat]]=!=0;





Options[LinearPhasePlot2D]={PlotRange\[Rule]{{-1,1},{-1,1}},
      AspectRatio\[Rule]Automatic,Frame\[Rule]True,FrameTicks\[Rule]{{0},{0}},
      NotableLineStyle\[Rule]RGBColor[1,0,0],NumberOfTrajectories\[Rule]5,
      WriteReport\[Rule]True,ShowField\[Rule]False,Oriented\[Rule]True, 
      ArrowDensity\[Rule]1,ArrowsAcrossSubdivisions\[Rule]True};

inverseRange[s_?MatrixQ]:=Map[Max,Inverse[s].{{1,-1,-1,1},{1,1,-1,-1}}];

equil={PointSize[.03],Point[{0,0}],GrayLevel[1],PointSize[.02],Point[{0,0}]};

wrongDirectionQ[mat_?MatrixQ][{pt1_List,
        pt2_,___}]:=((pt2-pt1).(mat.(pt1+pt2)/2)<0);




LinearPhasePlot2D[mat_?nodeQ,opts___Rule]:=
    Module[{sim,diag,\[Lambda]1,\[Lambda]2,wrtRptQ,shwFldQ,shwArrsQ,arwDnsty,
        n,style,fld,xmax,ymax,sol,vert,orizz,r,coeffList,basicTrajs,
        allTrajs},
      {sim,diag}=JordanDecomposition[mat];
      {\[Lambda]1,\[Lambda]2}=Transpose[diag,{1,1}];
      {wrtRptQ,shwFldQ,shwArrsQ,arwDnsty,n,
          style}={WriteReport,ShowField,Oriented, ArrowDensity,
              NumberOfTrajectories+1,NotableLineStyle}/.{opts}/.Options[
            LinearPhasePlot2D];
      If[wrtRptQ,Print[If[\[Lambda]1>0,"Repulsive","Attractive"]<>" node"],
        Null];
      fld:=
        PlotVectorField[mat.{x,y},{x,-.9,.9},{y,-.9,.9},
          DisplayFunction\[Rule]Identity];
      {xmax,ymax}=N[inverseRange[sim]];
      sol[c_]:=
        Map[N[sim].#&,
          Plot[c*Abs[x]^(\[Lambda]2/\[Lambda]1),
                Evaluate[{x,-Min[xmax,r],
                      Min[xmax,
                        r]}/.r\[RuleDelayed](ymax/
                            Abs[c])^(\[Lambda]1/\[Lambda]2)],
                DisplayFunction\[Rule]Identity][[1,1,
                1]]/.Line[{a___,{x1_?NonPositive,y1_},{x2_?NonNegative,y2_},
                  b___}]\[RuleDelayed]{Line[{a,{x1,y1},{0,0}}],
                Line[{{0,0},{x2,y2},b}]},{3}];
      vert={style,
            Map[N[sim].#&,{Line[{{0,-ymax},-{0,0}/10^3}],
                Line[{{0,0}/10^3,{0,ymax}}]},{3}]}//Flatten;
      orizz={style,
            Map[N[sim].#&,{Line[{{-xmax,0},{.01,.01}}],
                Line[{{0,0}/10^3,{xmax,0}}]},{3}]}//Flatten;
      coeffList=
        Join[#,-#]&[
          Table[(1-r)*ymax/(r*xmax)^(\[Lambda]2/\[Lambda]1),{r,1/n,1-1/n,
              1/n}]];
      basicTrajs={Map[sol,coeffList],vert,orizz,equil};
      allTrajs=
        If[shwArrsQ,
          clipAndPlaceArrows[basicTrajs,{-1,1},{-1,1},wrongDirectionQ[mat],
            arwDnsty,opts],basicTrajs];
      Show[{If[shwFldQ,fld,Sequence@@{}],Graphics[allTrajs]},
        PlotRange\[Rule]{{-1,1},{-1,1}},FilterOptions[Plot,opts],
        FilterOptions[Plot,Options[LinearPhasePlot2D]],
        DisplayFunction\[Rule]$DisplayFunction]];



LinearPhasePlot2D[mat_?saddleQ,opts___Rule]:=
    Module[{sim,diag,\[Lambda]1,\[Lambda]2,wrtRptQ,shwFldQ,shwArrsQ,arwDnsty,
        n,style,fld,xmax,ymax,sol0,sol,coeffList,vert,orizz,basicTrajs,
        allTrajs},
      {sim,diag}=JordanDecomposition[mat];
      {\[Lambda]1,\[Lambda]2}={diag[[1,1]],diag[[2,2]]};
      {wrtRptQ,shwFldQ,shwArrsQ,arwDnsty,n,
          style}={WriteReport,ShowField,Oriented, ArrowDensity,
              NumberOfTrajectories+1,NotableLineStyle}/.{opts}/.Options[
            LinearPhasePlot2D];
      If[wrtRptQ,Print["Saddle"],Null];
      fld:=
        PlotVectorField[mat.{x,y},{x,-.9,.9},{y,-.9,.9},
          DisplayFunction\[Rule]Identity];
      {xmax,ymax}=N[inverseRange[sim]];
      sol0[c_]:=
        Plot[c*Abs[x]^(\[Lambda]2/\[Lambda]1),
            Evaluate[{x,Abs[ymax/c]^(\[Lambda]1/\[Lambda]2),Min[xmax,1]}],
            DisplayFunction\[Rule]Identity][[1,1,1]];
      sol[c_]:={Map[N[sim].#&,sol0[c],{2}],
          Map[N[sim].{{-1,0},{0,1}}.#&,sol0[c],{2}]};
      coeffList=
        Join[#,-#]&[
          Table[r*ymax/(r*xmax)^(\[Lambda]2/\[Lambda]1),{r,1/n,1-1/n,1/n}]];
      vert={style,
            Map[N[sim].#&,{Line[{{0,-ymax},{0,0}}],
                Line[{{0,0},{0,ymax}}]},{3}]}//Flatten;
      orizz={style,
            Map[N[sim].#&,{Line[{{-xmax,0},{0,0}}],
                Line[{{0,0},{xmax,0}}]},{3}]}//Flatten;
      basicTrajs={Map[sol,coeffList],vert,orizz,equil};
      allTrajs=
        If[shwArrsQ,
          clipAndPlaceArrows[basicTrajs,{-1,1},{-1,1},wrongDirectionQ[mat],
            arwDnsty,opts],basicTrajs];
      Show[{If[shwFldQ,fld,Sequence@@{}],Graphics[allTrajs]},
        PlotRange\[Rule]{{-1,1},{-1,1}},FilterOptions[Plot,opts],
        FilterOptions[Plot,Options[LinearPhasePlot2D]],
        DisplayFunction\[Rule]$DisplayFunction]];



LinearPhasePlot2D[mat_?singularDistinctEigenvaluesQ,opts___?OptionQ]:=
    Module[{sim,canon,\[Lambda],wrtRptQ,shwFldQ,shwArrsQ,arwDnsty,n,style,fld,
        trasf,xmax,ymax,sol,vert,coeffList,basicTrajs,allTrajs},
      {sim,canon}=JordanDecomposition[mat];
      \[Lambda]=Select[Flatten[canon],#=!=0&,1][[1]];
      {wrtRptQ,shwFldQ,shwArrsQ,arwDnsty,n,
          style}={WriteReport,ShowField,Oriented, ArrowDensity,
              NumberOfTrajectories,NotableLineStyle}/.{opts}/.Options[
            LinearPhasePlot2D];
      If[wrtRptQ,
        Print["One null eigenvalue, the other one "<>
            If[\[Lambda]>0,"positive","negative"]],Null];
      fld:=
        PlotVectorField[mat.{x,y},{x,-.9,.9},{y,-.9,.9},
          DisplayFunction\[Rule]Identity];
      trasf=
        N[sim].If[canon[[1,1]]===\[Lambda],
              IdentityMatrix[2],{{0,1},{1,0}}].#&;
      {xmax,ymax}=N[inverseRange[sim]];
      sol[c_]:=
        Map[trasf,{Line[{{-xmax,c},{0,c}}],Line[{{0,c},{xmax,c}}]},{3}];
      vert={{GrayLevel[1],Thickness[.04],
            Line[trasf/@{{0,-ymax},{0,ymax}}]},{RGBColor[1,0,0],
              Dashing[{.02,.02}],Thickness[.01],style,
              Line[trasf/@{{0,-ymax},{0,ymax}}]}//Flatten};
      coeffList=ymax*Range[-n,n]/n;
      basicTrajs=Map[sol,coeffList];
      allTrajs=
        If[shwArrsQ,
          clipAndPlaceArrows[basicTrajs,{-1,1},{-1,1},wrongDirectionQ[mat],
            arwDnsty,opts],basicTrajs];
      Show[{If[shwFldQ,fld,Sequence@@{}],Graphics[{allTrajs,vert,equil}]},
        PlotRange\[Rule]{{-1,1},{-1,1}},FilterOptions[Plot,opts],
        FilterOptions[Plot,Options[LinearPhasePlot2D]],
        DisplayFunction\[Rule]$DisplayFunction]];



LinearPhasePlot2D[mat_?improperNodeQ,opts___Rule]:=
    Module[{sim,canon,\[Lambda],wrtRptQ,shwFldQ,shwArrsQ,arwDnsty,n,style,fld,
        xmax,ymax,sol,u,coeffList,orizz,basicTrajs,allTrajs},
      {sim,canon}=N[JordanDecomposition[mat]];
      \[Lambda]=canon[[1,1]];
      {wrtRptQ,shwFldQ,shwArrsQ,arwDnsty,n,
          style}={WriteReport,ShowField,Oriented, ArrowDensity,
              2NumberOfTrajectories,NotableLineStyle}/.{opts}/.Options[
            LinearPhasePlot2D];
      If[wrtRptQ,
        Print[If[\[Lambda]>0,"Repulsive","Attractive"]<>" improper node"],
        Null];
      fld:=
        PlotVectorField[mat.{x,y},{x,-.9,.9},{y,-.9,.9},
          DisplayFunction\[Rule]Identity];
      {xmax,ymax}=N[inverseRange[sim]];
      sol[c_]:=
        Map[N[sim].Reverse[#]&,
          Plot[c*y+y*Log[Max[Abs[y],.000001ymax]]/\[Lambda],{y,-ymax,ymax},
                DisplayFunction\[Rule]Identity][[1,1,
                1]]/.Line[{a___,{y1_?NonPositive,x1_},{y2_?NonNegative,x2_},
                  b___}]\[RuleDelayed]{Line[{a,{y1,x1},{0,0}}],
                Line[{{0,0},{y2,x2},b}]},{3}];
      u=Min[xmax,ymax];
      coeffList=
        Table[(Sin[r]*u-Cos[r]*u*Log[Cos[r]*u]/\[Lambda])/(Cos[r]*u),{r,-Pi/2+
              Pi/n,Pi/2-Pi/n,Pi/n}];
      orizz={style,
            Map[N[sim].#&,{Line[{{-xmax,0},{0,0}}],
                Line[{{0,0},{xmax,0}}]},{3}]}//Flatten;
      basicTrajs={Map[sol,coeffList],orizz,equil};
      allTrajs=
        If[shwArrsQ,
          clipAndPlaceArrows[basicTrajs,{-1,1},{-1,1},wrongDirectionQ[mat],
            arwDnsty,opts],basicTrajs];
      Show[{If[shwFldQ,fld,Sequence@@{}],Graphics[allTrajs]},
        PlotRange\[Rule]{{-1,1},{-1,1}},FilterOptions[Plot,opts],
        FilterOptions[Plot,Options[LinearPhasePlot2D]],
        DisplayFunction\[Rule]$DisplayFunction]];



LinearPhasePlot2D[mat_?nonNullMultipleOfIdentity,opts___Rule]:=
    Module[{\[Lambda],wrtRptQ,shwFldQ,shwArrsQ,arwDnsty,n,fld,sol,coeffList,
        basicTrajs,allTrajs},
      \[Lambda]=mat[[1,1]];
      {wrtRptQ,shwFldQ,shwArrsQ,arwDnsty,
          n}={WriteReport,ShowField,Oriented, ArrowDensity,
              NumberOfTrajectories}/.{opts}/.Options[LinearPhasePlot2D];
      If[wrtRptQ,
        Print[If[\[Lambda]>0,"Repulsive","Attractive"]<>
            " node with coincident eigenvalues"]];
      fld:=
        PlotVectorField[mat.{x,y},{x,-.9,.9},{y,-.9,.9},
          DisplayFunction\[Rule]Identity];
      sol[c_]:={Line[2{-{Cos[c],Sin[c]},{0,0}}],
          Line[2{{0,0},{Cos[c],Sin[c]}}]};
      coeffList=N[Pi*Range[2n]/(2n)];
      basicTrajs={Map[sol,coeffList],equil};
      allTrajs=
        If[shwArrsQ,
          clipAndPlaceArrows[basicTrajs,{-1,1},{-1,1},wrongDirectionQ[mat],
            arwDnsty,opts],basicTrajs];
      Show[{If[shwFldQ,fld,Sequence@@{}],Graphics[allTrajs]},
        PlotRange\[Rule]{{-1,1},{-1,1}},FilterOptions[Plot,opts],
        FilterOptions[Plot,Options[LinearPhasePlot2D]],
        DisplayFunction\[Rule]$DisplayFunction]];



LinearPhasePlot2D[mat_?nonNullNilpotentQ,opts___Rule]:=
    Module[{sim,canon,xmax,ymax,wrtRptQ,shwFldQ,shwArrsQ,arwDnsty,n,style,fld,
        sol,orizz,provisional,coeffList,basicTrajs,allTrajs},
      {sim,canon}=JordanDecomposition[mat];
      {xmax,ymax}=N[inverseRange[sim]];
      {wrtRptQ,shwFldQ,shwArrsQ,arwDnsty,n,
          style}={WriteReport,ShowField,Oriented, ArrowDensity,
              NumberOfTrajectories,NotableLineStyle}/.{opts}/.Options[
            LinearPhasePlot2D];
      If[wrtRptQ,Print["Two null eigenvalues"],Null];
      fld:=
        PlotVectorField[mat.{x,y},{x,-.9,.9},{y,-.9,.9},
          DisplayFunction\[Rule]Identity];
      sol[c_]:=
        Map[N[sim].#&,{Line[{{-xmax,c},{0,c}}],Line[{{0,c},{xmax,c}}]},{3}];
      orizz={{GrayLevel[1],Thickness[.04],
            provisional[(N[sim].#&)/@{{-xmax,0},{xmax,0}}]},{RGBColor[1,0,0],
              Dashing[{.02,.02}],Thickness[.01],style,
              provisional[(N[sim].#&)/@{{-xmax,0},{xmax,0}}]}//Flatten};
      coeffList=ymax*Complement[Range[-n,n],{0}]/n;
      basicTrajs={Map[sol,coeffList],orizz,equil};
      allTrajs=
        If[shwArrsQ,
            clipAndPlaceArrows[basicTrajs,{-1,1},{-1,1},wrongDirectionQ[mat],
              arwDnsty,opts],basicTrajs]/.provisional\[Rule]Line;
      Show[{If[shwFldQ,fld,Sequence@@{}],Graphics[allTrajs]},
        PlotRange\[Rule]{{-1,1},{-1,1}},FilterOptions[Plot,opts],
        FilterOptions[Plot,Options[LinearPhasePlot2D]],
        DisplayFunction\[Rule]$DisplayFunction]];



LinearPhasePlot2D[mat_?nullMatrixQ,opts___Rule]:=
    Show[Graphics[equil],PlotRange\[Rule]{{-1,1},{-1,1}},
      FilterOptions[Plot,opts],
      If[WriteReport/.{opts}/.Options[LinearPhasePlot2D],Print["Null matrix"],
        Null];
      FilterOptions[Plot,Options[LinearPhasePlot2D]],
      DisplayFunction\[Rule]$DisplayFunction];



LinearPhasePlot2D[mat_?centerQ,opts___Rule]:=
    Module[{sim,canon,xmax,ymax,wrtRptQ,shwFldQ,shwArrsQ,arwDnsty,n,style,fld,
        symAxes,\[Theta]0,unitCirc,sol,coeffList,basicTrajs,allTrajs,ax},
      {sim,canon}=realCanonicalForm[mat];
      {xmax,ymax}=N[inverseRange[sim]];
      {wrtRptQ,shwFldQ,shwArrsQ,arwDnsty,n,
          style}={WriteReport,ShowField,Oriented, ArrowDensity,
              1+NumberOfTrajectories,NotableLineStyle}/.{opts}/.Options[
            LinearPhasePlot2D];
      If[wrtRptQ,Print["Center (periodic orbits)"],Null];
      fld:=
        PlotVectorField[mat.{x,y},{x,-.9,.9},{y,-.9,.9},
          DisplayFunction\[Rule]Identity];
      symAxes=Eigensystem[Transpose[sim].sim][[2]];
      \[Theta]0=N[ArcTan@@symAxes[[1]]]+Pi/2;
      unitCirc=Line[
          Table[{Cos[\[Theta]],
                Sin[\[Theta]]},{\[Theta],\[Theta]0,\[Theta]0+2Pi-2Pi/80.,
                2Pi/80.}]~Join~{{Cos[\[Theta]0],Sin[\[Theta]0]}}];
      sol[c_]:=Map[c*N[sim].#&,unitCirc,{2}];
      coeffList=Max[xmax,ymax]*Range[2,n]^2/n^2;
      basicTrajs=Map[sol,coeffList];
      allTrajs=
        If[shwArrsQ,
          clipAndPlaceArrows[basicTrajs,{-1,1},{-1,1},wrongDirectionQ[mat],
            arwDnsty,opts],basicTrajs];
      ax[i_]:={Dashing[{.02,.02}],style,
            Map[N[sim].#&,
              Line[Sqrt[2]Max[xmax,ymax]/
                    Sqrt[symAxes[[i]].symAxes[[i]]]{-symAxes[[i]],
                    symAxes[[i]]}],{2}]}//Flatten;
      Show[{If[shwFldQ,fld,Sequence@@{}],
          Graphics[{allTrajs,ax[1],ax[2],equil}]},FilterOptions[Plot,opts],
        FilterOptions[Plot,Options[LinearPhasePlot2D]],
        DisplayFunction\[Rule]$DisplayFunction]];



LinearPhasePlot2D[mat_?spiralQ,opts___Rule]:=
    Module[{sim,canon,xmax,ymax,\[Alpha],\[Beta],wrtRptQ,shwFldQ,shwArrsQ,
        arwDnsty,n,style,fld,basicSpir,sol,coeffList,basicTrajs,allTrajs,
        symAxes,ax},
      {sim,canon}=realCanonicalForm[mat];{xmax,ymax}=N[inverseRange[sim]];
      {\[Alpha],\[Beta]}={canon[[1,1]],canon[[2,1]]};
      {wrtRptQ,shwFldQ,shwArrsQ,arwDnsty,n,
          style}={WriteReport,ShowField,Oriented, ArrowDensity,
              2NumberOfTrajectories,NotableLineStyle}/.{opts}/.Options[
            LinearPhasePlot2D];
      If[wrtRptQ,Print[If[\[Alpha]>0,"Repulsive","Attractive"]<>" spirals"],
        Null];
      fld:=
        PlotVectorField[mat.{x,y},{x,-.9,.9},{y,-.9,.9},
          DisplayFunction\[Rule]Identity];
      basicSpir=
        ParametricPlot[
            Exp[\[Alpha]*\[Theta]]{Cos[\[Beta]*\[Theta]],
                Sin[\[Beta]*\[Theta]]},
            Evaluate[{\[Theta],Log[.01Min[xmax,ymax]]/\[Alpha],
                Log[Sqrt[xmax^2+ymax^2]]/\[Alpha]}],
            DisplayFunction\[Rule]Identity][[1,1,1]];
      sol[c_]:=
        Map[N[sim].{{Cos[c],Sin[c]},{-Sin[c],Cos[c]}}.#&,basicSpir,{2}];
      coeffList=Range[n]*2Pi/n;
      basicTrajs=Map[sol,coeffList];
      allTrajs=
        If[shwArrsQ,
          clipAndPlaceArrows[basicTrajs,{-1,1},{-1,1},wrongDirectionQ[mat],
            arwDnsty,opts],basicTrajs];
      symAxes=Eigensystem[Transpose[sim].sim][[2]];
      ax[i_]:={Dashing[{.02,.02}],style,
            Map[N[sim].#&,
              Line[Sqrt[2]Max[xmax,ymax]/
                    Sqrt[symAxes[[i]].symAxes[[i]]]{-symAxes[[i]],
                    symAxes[[i]]}],{2}]}//Flatten;
      Show[{If[shwFldQ,fld,Sequence@@{}],
          Graphics[{allTrajs,ax[1],ax[2],equil}]},FilterOptions[Plot,opts],
        FilterOptions[Plot,Options[LinearPhasePlot2D]],
        DisplayFunction\[Rule]$DisplayFunction]];







trigFunctionsAndValueMatrix[conditionsStructure_List,timesList_List,t_Symbol,
      periodLength_:(2Pi)]:=Module[{numberOfConditions,baseFunctions,f,g},
      numberOfConditions=conditionsStructure//Flatten//Length;
      baseFunctions[r_]=
        Take[Flatten[
            Join[{1},
              Table[{Cos[2Pi*k*r/periodLength],Sin[2Pi*k*r/periodLength]},{k,
                  Ceiling[numberOfConditions/2]+1}]]],numberOfConditions+1];
      f[a_,{k_,j_:1}]:=Derivative[j-1][g][timesList[[k]]];
      {g[t],Flatten[MapIndexed[f,conditionsStructure,{-1}]]}/.g\[Rule]
          baseFunctions];



Options[TrigInterpolation]={EvaluateOnCoefficients\[Rule]Identity,
      Period\[Rule]Automatic};
TrigInterpolation[pointList:{{_?NumericQ,_?NumericQ|{__?NumericQ}}..},
      t_Symbol,opts___?OptionQ]:=
    Module[{funct,xlist,derivativesList,xmin,xmax,pl,periodLength,
        derivativesListStructure,trigValueMatrix,coeff},
      funct=EvaluateOnCoefficients/.{opts}/.Options[TrigInterpolation];
      xlist=Map[First,pointList];
      derivativesList=Map[Flatten[Rest[#]]&,pointList];
      {xmin,xmax}={Min[xlist],Max[xlist]};
      pl=Period/.{opts}/.Options[TrigInterpolation];
      periodLength=
        Which[pl===Automatic,(xmax-xmin)*3,Element[N[pl],Reals]===True,pl,
          True,(xmax-xmin)*3];
      derivativesListStructure=derivativesList/._?NumericQ\[Rule]1;
      {baseFunctions,trigValueMatrix}=
        trigFunctionsAndValueMatrix[derivativesListStructure,xlist,t,
          periodLength];
      coeff=Map[funct,LinearSolve[trigValueMatrix,Flatten[derivativesList]]];
      If[Head[coeff]===LinearSolve,Null,coeff.baseFunctions]];

TrigInterpolation[pointList:{__?NumericQ},t_Symbol,opts___?OptionQ]:=
    TrigInterpolation[Transpose[{Range[Length[pointList]],pointList}],t,opts];



Options[OpenCurveInterpolation]={EvaluateOnCoefficients\[Rule]Identity,
      ShowTimesListQ\[Rule]False,Period\[Rule]Automatic};
OpenCurveInterpolation[
      pointList:{({_?NumericQ,_?NumericQ}|{{_?NumericQ,_?NumericQ}..})..},
      t_Symbol,opts___?OptionQ]:=
    Module[{stlQ,funct,x,y,conditionsStructure,conditionsPerPoint,timesList,
        tmax,pl,periodLength,baseFunctions,trigValueMatrix,coeffx,coeffy,
        result},
      stlQ=((ShowTimesListQ/.{opts}/.Options[ClosedCurveInterpolation])===
            True);
      funct=
        EvaluateOnCoefficients/.{opts}/.Options[ClosedCurveInterpolation];
      x=pointList/.{a_?NumericQ,_}\[RuleDelayed]a;
      y=pointList/.{_,b_?NumericQ}\[RuleDelayed]b;
      conditionsStructure=x/._?NumericQ\[Rule]1;
      conditionsPerPoint=Map[Length[Flatten[#]]&,pointList]/2;
      timesList=FoldList[Plus,0,ListConvolve[{1,1},conditionsPerPoint]];
      tmax=Last[timesList];
      pl=Period/.{opts}/.Options[OpenCurveInterpolation];
      periodLength=
        Which[pl===Automatic,tmax*3,Element[N[pl],Reals]===True,pl,True,
          tmax*3];
      {baseFunctions,trigValueMatrix}=
        trigFunctionsAndValueMatrix[conditionsStructure,timesList,t,
          periodLength];
      coeffx=Map[funct,LinearSolve[trigValueMatrix,Flatten[x]]];
      coeffy=Map[funct,LinearSolve[trigValueMatrix,Flatten[y]]];
      result=
        {baseFunctions.coeffx,baseFunctions.coeffy};
      If[Or[Head[coeffx]===LinearSolve,Head[coeffy]===LinearSolve],
        Null,{result,If[stlQ,timesList,Sequence@@{}]}]];



OpenCurveInterpolation[
      pointList:{({_?NumericQ,_?NumericQ,_?
                    NumericQ}|{{_?NumericQ,_?NumericQ,_?NumericQ}..})..},
      t_Symbol,opts___?OptionQ]:=
    Module[{stlQ,funct,x,y,conditionsStructure,conditionsPerPoint,timesList,
        tmax,pl,periodLength,baseFunctions,trigValueMatrix,coeffx,coeffy,
        result},
      stlQ=((ShowTimesListQ/.{opts}/.Options[ClosedCurveInterpolation])===
            True);
      funct=
        EvaluateOnCoefficients/.{opts}/.Options[ClosedCurveInterpolation];
      x=pointList/.{a_?NumericQ,__}\[RuleDelayed]a;
      y=pointList/.{_,b_?NumericQ,_}\[RuleDelayed]b;
      z=pointList/.{_,_,c_?NumericQ}\[RuleDelayed]c;
      conditionsStructure=x/._?NumericQ\[Rule]1;
      conditionsPerPoint=Map[Length[Flatten[#]]&,pointList]/2;
      timesList=FoldList[Plus,0,ListConvolve[{1,1},conditionsPerPoint]];
      tmax=Last[timesList];
      pl=Period/.{opts}/.Options[OpenCurveInterpolation];
      periodLength=
        Which[pl===Automatic,tmax*3,Element[N[pl],Reals]===True,pl,True,
          tmax*3];
      {baseFunctions,trigValueMatrix}=
        trigFunctionsAndValueMatrix[conditionsStructure,timesList,t,
          periodLength];
      coeffx=Map[funct,LinearSolve[trigValueMatrix,Flatten[x]]];
      coeffy=Map[funct,LinearSolve[trigValueMatrix,Flatten[y]]];
      coeffz=Map[funct,LinearSolve[trigValueMatrix,Flatten[z]]];
      result=
        {baseFunctions.coeffx,baseFunctions.coeffy,baseFunctions.coeffz};
      If[Or[Head[coeffx]===LinearSolve,Head[coeffy]===LinearSolve],
        Null,{result,If[stlQ,timesList,Sequence@@{}]}]];





Options[ClosedCurveInterpolation]={EvaluateOnCoefficients\[Rule]Identity,
      ShowTimesListQ\[Rule]False};
ClosedCurveInterpolation[
      pointList:{({_?NumericQ,_?NumericQ}|{{_?NumericQ,_?NumericQ}..})..},
      t_Symbol,opts___?OptionQ]:=
    Module[{stlQ,funct,x,y,conditionsStructure,conditionsPerPoint,timesList,r,
        f,g,baseFunctions,trigValueMatrix,coeffx,coeffy,result},
      stlQ=((ShowTimesListQ/.{opts}/.Options[ClosedCurveInterpolation])===
            True);
      funct=
        EvaluateOnCoefficients/.{opts}/.Options[ClosedCurveInterpolation];
      x=pointList/.{a_?NumericQ,_}\[RuleDelayed]a;
      y=pointList/.{_,b_?NumericQ}\[RuleDelayed]b;
      conditionsStructure=x/._?NumericQ\[Rule]1;
      conditionsPerPoint=Map[Length[Flatten[#]]&,pointList]/2;
      timesList=
        2Pi(Drop[#,-1]/Last[#]&)[
            FoldList[Plus,0,ListConvolve[{1,1},conditionsPerPoint,{1,1}]]];
      {baseFunctions,trigValueMatrix}=
        trigFunctionsAndValueMatrix[conditionsStructure,timesList,t];
      coeffx=Map[funct,LinearSolve[trigValueMatrix,Flatten[x]]];
      coeffy=Map[funct,LinearSolve[trigValueMatrix,Flatten[y]]];
      result=
        {baseFunctions.coeffx,baseFunctions.coeffy};
      If[Or[Head[coeffx]===LinearSolve,Head[coeffy]===LinearSolve],Null,
        If[stlQ,{result,timesList},result]]];



ClosedCurveInterpolation[
      pointList:{({_?NumericQ,_?NumericQ,_?
                    NumericQ}|{{_?NumericQ,_?NumericQ,_?NumericQ}..})..},
      t_Symbol,opts___?OptionQ]:=
    Module[{stlQ,funct,x,y,conditionsStructure,conditionsPerPoint,timesList,r,
        f,g,baseFunctions,trigValueMatrix,coeffx,coeffy,result},
      stlQ=((ShowTimesListQ/.{opts}/.Options[ClosedCurveInterpolation])===
            True);
      funct=
        EvaluateOnCoefficients/.{opts}/.Options[ClosedCurveInterpolation];
      x=pointList/.{a_?NumericQ,__}\[RuleDelayed]a;
      y=pointList/.{_,b_?NumericQ,_}\[RuleDelayed]b;
      z=pointList/.{_,_,c_?NumericQ}\[RuleDelayed]c;
      conditionsStructure=x/._?NumericQ\[Rule]1;
      conditionsPerPoint=Map[Length[Flatten[#]]&,pointList]/2;
      timesList=
        2Pi(Drop[#,-1]/Last[#]&)[
            FoldList[Plus,0,ListConvolve[{1,1},conditionsPerPoint,{1,1}]]];
      {baseFunctions,trigValueMatrix}=
        trigFunctionsAndValueMatrix[conditionsStructure,timesList,t];
      coeffx=Map[funct,LinearSolve[trigValueMatrix,Flatten[x]]];
      coeffy=Map[funct,LinearSolve[trigValueMatrix,Flatten[y]]];
      coeffz=Map[funct,LinearSolve[trigValueMatrix,Flatten[z]]];
      result=
        {baseFunctions.coeffx,baseFunctions.coeffy,baseFunctions.coeffz};
      If[Or[Head[coeffx]===LinearSolve,Head[coeffy]===LinearSolve],Null,
        If[stlQ,{result,timesList},result]]];



checkDimensions[pointList_]:=
    MemberQ[{{2},{3}},Union@Map[Length,Level[pointList,{-2}]]];

ParametricTrigInterpolation[
    pointList:{({__?NumericQ}|{{__?NumericQ}..})..}/;
      checkDimensions[pointList],t_Symbol,opts___?OptionQ]:=
  If[TrueQ[ClosedCurve/.{opts}],ClosedCurveInterpolation[pointList,t,opts],
    OpenCurveInterpolation[pointList,t,opts]]





Options[TrigInterpolationPlot]={ShowListPlot\[Rule]False,
      ListPlotStyle\[Rule]PointSize[.02],ShowFormula\[Rule]False};
TrigInterpolationPlot[pointList:{{_?NumericQ,__?NumericQ}..},xmin_?NumericQ,
      xmax_?NumericQ,opts___?OptionQ]:=
    Module[{slpQ,sformQ,interpFunct,t,curve,listPl,finalPlot},
      {slpQ,sformQ}=
        Map[TrueQ,{ShowListPlot,ShowFormula}/.{opts}/.Options[
              TrigInterpolationPlot]];
      interpFunct=
        TrigInterpolation[pointList,t,FilterOptions[TrigInterpolation,opts]];
      If[interpFunct===Null,Return[Null]];
      curve=
        Plot[interpFunct,{t,xmin,xmax},DisplayFunction\[Rule]Identity,
          Evaluate[FilterOptions[Plot,opts]]];
      listPl:=
        ListPlot[Map[Take[#,2]&,pointList],
          PlotStyle\[Rule](ListPlotStyle/.{opts}/.Options[
                  TrigInterpolationPlot]),DisplayFunction\[Rule]Identity];
      finalPlot:=
        Show[If[slpQ,{curve,listPl},curve],
          Evaluate[
            FilterOptions[Graphics,opts,
              DisplayFunction\[Rule]$DisplayFunction]]];
      If[sformQ,{finalPlot,Evaluate[interpFunct/.t\[Rule]Slot[1]]&},
        finalPlot]];



Options[TrigInterpolationParametricPlot]=
    Join[{OrientedCurve\[Rule]False,ClosedCurve\[Rule]False,
        FilledClosedCurve\[Rule]False,ShowListPlot\[Rule]False,
        ListPlotStyle\[Rule]PointSize[.02],ShowFormula\[Rule]False,
        ShowTimesListQ\[Rule]False}];

TrigInterpolationParametricPlot[
      pointList:{({__?NumericQ}|{{__?NumericQ}..})..}/;
        checkDimensions[pointList],opts___?OptionQ]:=
    Module[{dimen,orntdQ,clsdQ,filledclsdQ,slpQ,sformQ,stlstQ,paramCurve,tmax,
        basicPlot,pointsPlot,endPlot},
      dimen=Level[pointList,{-2}]//First//Length;
      {orntdQ,clsdQ,filledclsdQ,slpQ,sformQ,stlstQ}=
        Map[TrueQ,{OrientedCurve,ClosedCurve,FilledClosedCurve,ShowListPlot,
                ShowFormula,ShowTimesListQ}/.{opts}/.Options[
              InterpolationParametricPlot]];
      If[filledclsdQ,clsdQ=True];
      If[Not@clsdQ,{paramCurve,tlst}=
          OpenCurveInterpolation[pointList,t,ShowTimesListQ\[Rule]True,
            Evaluate[FilterOptions[OpenCurveInterpolation,opts]]]];
      If[clsdQ,{paramCurve,tlst}=
          ClosedCurveInterpolation[pointList,t,ShowTimesListQ\[Rule]True,
            Evaluate[FilterOptions[ClosedCurveInterpolation,opts]]]];
      If[paramCurve===Null,Return[Null]];
      tmax=If[clsdQ,2Pi,Last@tlst];
      (basicPlot/;dimen\[Equal]2):=
        basicPlot=
          OrientedParametricPlot[paramCurve,{t,0,tmax},
              DisplayFunction\[Rule]Identity,
              Evaluate[If[orntdQ,Sequence@@{},HowManyArrows\[Rule]0]],
              Evaluate[FilterOptions[OrientedParametricPlot,opts]]]/.If[
              filledclsdQ,
              Line[pts_]\[RuleDelayed]{{Sequence@@
                      Flatten[{Graphics`FilledPlot`Fills/.{opts}/.{Graphics`\
FilledPlot`Fills\[Rule]GrayLevel[.5]}}],Polygon[pts]},Line[pts]},{}];
      (basicPlot/;dimen\[Equal]3):=
        basicPlot=
          OrientedParametricPlot3D[Evaluate[paramCurve],{t,0,tmax},
            DisplayFunction\[Rule]Identity,
            Evaluate[If[orntdQ,Sequence@@{},HowManyArrows\[Rule]0]],
            Evaluate[FilterOptions[OrientedParametricPlot3D,opts]]];
      pointsPlot:=
        If[dimen\[Equal]2,Graphics,
            Graphics3D][{Sequence@@
              Flatten[{ListPlotStyle/.{opts}/.Options[
                      TrigInterpolationParametricPlot]}],
            Map[Point[Take[Flatten[#],dimen]]&,pointList]}];
      endPlot:=Show[If[slpQ,{basicPlot,pointsPlot},
            basicPlot],
          Evaluate[FilterOptions[Graphics,opts]],
          DisplayFunction\[Rule]$DisplayFunction];
      If[sformQ,{endPlot,Evaluate[First@paramCurve/.t\[Rule]Slot[1]]&},
        endPlot]];



TrigInterpolationParametricPlot3D[
      pointList:{({_?NumericQ,_?NumericQ,_?
                    NumericQ}|{{_?NumericQ,_?NumericQ,_?NumericQ}..})..},
      opts___]:=
    InterpolationParametricPlot[pointList,opts];



TrigInterpolationDraw[pointList:{{_?NumericQ,__?NumericQ}..},xmin_?NumericQ,
      xmax_?NumericQ,opts___?OptionQ]:=Block[{$DisplayFunction=Identity},
      TrigInterpolationPlot[pointList,xmin,xmax,ShowFormula\[Rule]False,
          opts][[1]]];

TrigInterpolationParametricDraw[
      pointList:{({__?NumericQ}|{{__?NumericQ}..})..}/;
        checkDimensions[pointList],opts___?OptionQ]:=
    Block[{$DisplayFunction=Identity},
      TrigInterpolationParametricPlot[pointList,ShowFormula\[Rule]False,
          opts][[1]]];

TrigInterpolationParametricDraw3D[
      pointList:{({_?NumericQ,_?NumericQ,_?
                      NumericQ}|{{_?NumericQ,_?NumericQ,_?NumericQ}..})..}/;
        checkDimensions[pointList],opts___?OptionQ]:=
    Block[{$DisplayFunction=Identity},
      TrigInterpolationParametricPlot3D[pointList,ShowFormula\[Rule]False,
          opts][[1]]];





Options[PolynomialLevelSetTrigInterpolation]=
    Options[ClosedCurveInterpolation];

PolynomialLevelSetTrigInterpolation::"NonExactInput"=
    "PolynomialLevelSetInterpolation is designed only for exact (infinite \
precision) numeric input.";

PolynomialLevelSetTrigInterpolation[
      pointList:{({_?NumericQ,_?NumericQ}|{{_?NumericQ,_?NumericQ}..})..}/;
        Precision[pointList]<Infinity,t_Symbol,x_Symbol,y_Symbol,
      opts___Rule]:=(Message[
        PolynomialLevelSetInterpolation::"NonExactInput"];Null);

PolynomialLevelSetTrigInterpolation[
      pointList:{({_?NumericQ,_?NumericQ}|{{_?NumericQ,_?NumericQ}..})..}/;
        Precision[pointList]\[Equal]Infinity,t_Symbol,x_Symbol,y_Symbol,
      opts___Rule]:=
    Module[{closedQ,funct,parametricContour,maxDenom,poly,a,b,
        simplifiedPoly},
      {closedQ,
          funct}={ClosedCurve,EvaluateOnCoefficients}/.{opts}/.Options[
            ClosedCurveInterpolation];
      parametricContour=ParametricTrigInterpolation[pointList,t,opts];
      If[parametricContour===Null,Return[Null]];
      maxDenom:=
        Max[1,Cases[parametricContour,
            Cos[Pi*t*Rational[_,n_]]|Sin[Pi*t*Rational[1,n_]]\[RuleDelayed]
              n,{0,Infinity}]];
      poly=Eliminate[
            Join[Thread[{x,y}==
                    TrigExpand[
                      Take[Flatten[parametricContour],2]/.If[
                          TrueQ[closedQ],{},t\[Rule]t*maxDenom/Pi]]/.{Cos[
                        t]\[Rule]a,Sin[t]\[Rule]b}],{a^2+b^2\[Equal]1}],{a,
              b}]/.Equal\[Rule]Subtract;
      simplifiedPoly=Collect[poly,{x^(_:1)y^(_:1),x^(_:1),y^(_:1)},funct];
      {parametricContour,simplifiedPoly}];



SetAttributes[LinearClipPlot3D, HoldRest];

Options[LinearClipPlot3D]={PrepareForSlices\[Rule]False,
      ReverseOrientation\[Rule]False,ContourStyle\[Rule]Automatic};

LinearClipPlot3D[obj_SurfaceGraphics,other___]:=
    LinearClipPlot3D[Graphics3D[obj],other];

LinearClipPlot3D[obj_Graphics3D,
      rel_/;Or[MemberQ[{Less,LessEqual,Greater,GreaterEqual},Head[rel]]&&
            Length[rel]>2,Head[rel]===Inequality],var__Symbol,opts___Rule]:=
    LinearClipPlot3D[obj,Evaluate@LogicalExpand[rel],var,
        opts]//.{a___Rule,b_\[Rule]c_,d___Rule,b_\[Rule]f_,
          g___Rule}\[RuleDelayed]{a,b\[Rule]c,d,g};

LinearClipPlot3D[obj_Graphics3D,rel_And,var__Symbol,opts___Rule]:=
    Show[Fold[
          LinearClipPlot3D[#1,#2,var,DisplayFunction\[Rule]Identity,opts]&,
          obj,List@@rel],
        FilterOptions[Graphics3D,opts],
        Sequence@@Rest[obj]]//.{a___Rule,b_\[Rule]c_,d___Rule,b_\[Rule]f_,
          g___Rule}\[RuleDelayed]{a,b\[Rule]c,d,g};

LinearClipPlot3D[obj_Graphics3D,
        rel_/;MemberQ[{Less,LessEqual,Greater,GreaterEqual},Head[rel]]&&
            Length[rel]\[Equal]2,var__Symbol,
        opts___Rule]/;(PolynomialQ[Subtract@@rel,{var}]&&
          Max[(Exponent[Expand[Subtract@@rel],#1]&)/@{var}]===1):=
    Module[{ratObj,strictRel,weakRel,strictNegRel,weakNegRel,eqRel,interiorQ,
        weakInteriorQ,exteriorQ,weakExteriorQ,onBoundaryQ,interiorQList,
        weakInteriorQList,exteriorQList,weakExteriorQList,borderTouchingQ,
        flatOnPlaneQ,toThrowQ,winnowed,inters,clipLine,removeDuplicatePts,
        clipContour,beyondClipLine,beyondClipContour,prepareQ,boundaryLine,
        crossPr,parallelPolygons,normalVectorToPolygon,
        normalVectorToClipPlane,positivelyOrientedQ,
        rulesForConnectingSegments,dontReverseQ,removeDuplicateEndPoints,
        boundaryStyle,boundary,withoutBoundary,withClippedPolygons},
      ratObj=Rationalize[obj,1/10^6];
      If[Not[MatchQ[ratObj,Graphics3D[_List,___]]],MapAt[List,ratObj,1]];
      strictRel=
        Rationalize[
          rel/.\[InvisibleSpace]{LessEqual\[Rule]Less,
              GreaterEqual\[Rule]Greater},1/10^6];
      weakRel=strictRel/.{Less\[Rule]LessEqual,Greater\[Rule]GreaterEqual};
      strictNegRel=strictRel/.{Less\[Rule]Greater,Greater\[Rule]Less};
      weakNegRel=
        strictNegRel/.{Less\[Rule]LessEqual,Greater\[Rule]GreaterEqual};
      eqRel=strictRel/.{Less\[Rule]Equal,Greater\[Rule]Equal};
      interiorQ[pt_List]:=strictRel/.\[InvisibleSpace]Thread[{var}\[Rule]pt];
      weakInteriorQ[pt_List]:=
        weakRel/.\[InvisibleSpace]Thread[{var}\[Rule]pt];
      exteriorQ[pt_List]:=strictNegRel/.Thread[{var}\[Rule]pt];
      weakExteriorQ[pt_List]:=
        weakNegRel/.\[InvisibleSpace]Thread[{var}\[Rule]pt];
      onBoundaryQ[pt_List]:=eqRel/.Thread[{var}\[Rule]pt];
      interiorQList[pts_List]:=interiorQ/@pts;
      weakInteriorQList[pts_List]:=weakInteriorQ/@pts;
      exteriorQList[pts_List]:=exteriorQ/@pts;
      weakExteriorQList[pts_List]:=weakExteriorQ/@pts;
      flatOnPlaneQ[pts_List]:=
        And[And@@weakInteriorQList[pts],And@@weakExteriorQList[pts]];
      borderTouchingQ[pts_List]:=
        And[Or@@weakInteriorQList[pts],Or@@weakExteriorQList[pts],
          Not[flatOnPlaneQ[pts]]];
      toThrowQ[Polygon[pts_List]]:=Or[And@@exteriorQList[pts]];
      winnowed=
        ratObj/.\[InvisibleSpace]pol_Polygon?
              toThrowQ\[RuleDelayed]Sequence@@{};
      inters[pt1_List,pt2_List]:=
        t pt1+(1-t) pt2/.\[InvisibleSpace]Solve[
              eqRel/.\[InvisibleSpace]Thread[{var}\[Rule]t*pt1+(1-t) pt2],
              t][[1]];clipLine[pt1_List?exteriorQ,pt2_List?exteriorQ]:=
        Sequence@@{};
      clipLine[pt1_List?interiorQ,pt2_List?weakExteriorQ]:={pt1,
          inters[pt1,pt2]};
      clipLine[pt1_List?weakInteriorQ,pt2_List?exteriorQ]:={pt1,
          inters[pt1,pt2]};
      clipLine[pt1_List?weakExteriorQ,pt2_List?interiorQ]:={inters[pt1,pt2],
          pt2};clipLine[pt1_List?exteriorQ,
          pt2_List?weakInteriorQ]:={inters[pt1,pt2],pt2};
      clipLine[pt1_List?weakInteriorQ,pt2_List?weakInteriorQ]:={pt1,pt2};
      removeDuplicatePts=({a___,b_List,b_,c___}\[RuleDelayed]{a,b,c});
      clipContour[pts_List]:=
        Flatten[Apply[clipLine,Partition[Append[pts,First[pts]],2,1],1],
            1]//.removeDuplicatePts;
      beyondClipLine[pt1_List?interiorQ,pt2_List?interiorQ]:=Sequence@@{};
      beyondClipLine[pt1_List?weakInteriorQ,
          pt2_List?exteriorQ]:={inters[pt1,pt2],pt2};
      beyondClipLine[pt1_List?interiorQ,
          pt2_List?weakExteriorQ]:={inters[pt1,pt2],pt2};
      beyondClipLine[pt1_List?exteriorQ,pt2_List?weakInteriorQ]:={pt1,
          inters[pt1,pt2]};
      beyondClipLine[pt1_List?weakExteriorQ,pt2_List?interiorQ]:={pt1,
          inters[pt1,pt2]};
      beyondClipLine[pt1_List?weakExteriorQ,pt2_List?weakExteriorQ]:={pt1,
          pt2};
      beyondClipContour[pts_List]:=
        Flatten[Apply[beyondClipLine,Partition[Append[pts,First[pts]],2,1],1],
            1]//.removeDuplicatePts;
      prepareQ=
        PrepareForSlices/.\[InvisibleSpace]{opts}/.\[InvisibleSpace]Options[
            LinearClipPlot3D];
      boundaryLine[clipCtr_List]:=
        Cases[
          Partition[clipCtr,2,1],{p__List?onBoundaryQ}\[RuleDelayed]
            Line[{p}]];
      normalVectorToPolygon[polyPts_List]:=
        Cross@@Map[Last[#]-First[#]&,{polyPts,RotateLeft[polyPts]}];
      normalVectorToClipPlane=Outer[D,{Subtract@@rel},{var}]//First;
      positivelyOrientedQ[polyPts_List,boundaryPts_List]:=
        Positive[
          Det[{normalVectorToPolygon[polyPts],
              Last[boundaryPts]-First[boundaryPts],
              normalVectorToClipPlane}]];
      positivelyOrientedQ[polyPts_List,{}]:=False;
      rulesForConnectingSegments={({a___,Line[{b_List,c1_,c___}],d___,
                  Line[{e___,e1_,b_}],f___}/;c1=!=e1)\[RuleDelayed]
            {Line[{e,e1,b,c1,c}],a,d,
              f},({a___,Line[{c___,c1_,b_List}],d___,Line[{b_,e1_,e___}],
                  f___}/;c1=!=e1)\[RuleDelayed]{Line[{c,c1,b,e1,e}],a,d,f}};
      dontReverseQ=
        Not@TrueQ[ReverseOrientation/.{opts}/.Options[LinearClipPlot3D]];
      removeDuplicateEndPoints=
        Polygon[{a_,b___,a_}]\[RuleDelayed]Polygon[{a,b}];
      boundaryStyle=ContourStyle/.{opts}/.Options[LinearClipPlot3D];
      If[boundaryStyle===Automatic,boundaryStyle={}];
      crossPr[{a_,b_,c_},{e_,f_,g_}]={-c f+b g,c e-a g,-b e+a f};
      parallelPolygons[{pt1_,pt2_,pt3_,pts___}]:=
        With[{normal=crossPr[pt1-pt2,pt2-pt3]/10^10},{Polygon[
              Map[#+normal&,{pt1,pt2,pt3,pts}]],
            Polygon[Map[#-normal&,{pt1,pt2,pt3,pts}]]}];
      boundary={};
      withoutBoundary:=
        withoutBoundary=
          winnowed/.\[InvisibleSpace]{Polygon[
                    pts_List/;
                      Length[pts]>2&&
                        flatOnPlaneQ[pts]]\[RuleDelayed](AppendTo[boundary,
                      parallelPolygons[pts]];Polygon[pts]),
                
                Polygon[
                    pts_List?
                      borderTouchingQ]\[RuleDelayed]Module[{clCon=
                        clipContour[pts],bClCon=beyondClipContour[pts],
                      bndLine},
                    
                    bndLine=
                      Union[boundaryLine[
                            Join[clCon,bClCon]//.removeDuplicatePts]/.Line[
                              segment_/;
                                Not@positivelyOrientedQ[pts,
                                    segment]]\[RuleDelayed]Line[
                              Reverse[segment]]];
                    AppendTo[boundary,bndLine];
                    Sequence@@{Polygon[clCon],
                        Polygon[bClCon]}]}/.removeDuplicateEndPoints;
      withClippedPolygons:=
        Show[{withoutBoundary;winnowed,
            Graphics3D[
              Join[{Sequence@@
                    Flatten[{If[FreeQ[boundary,Polygon],boundaryStyle,
                          If[FreeQ[boundaryStyle,
                              colorSpecPattern],{boundaryStyle,EdgeForm[],
                              SurfaceColor[GrayLevel[0]]},{boundaryStyle,
                              EdgeForm[],
                              SurfaceColor[
                                Last@Cases[boundaryStyle,
                                    colorSpecPattern,{0,Infinity}]]}]]}]},
                Union[Flatten[boundary]]//.rulesForConnectingSegments]]},
          DisplayFunction\[Rule]Identity];
      Show[
        If[prepareQ,withClippedPolygons,
          winnowed/.\[InvisibleSpace]Polygon[
                  pts_List?borderTouchingQ]\[RuleDelayed]Polygon[
                  clipContour[pts]]/.removeDuplicateEndPoints],
        FilterOptions[Graphics3D,opts,Sequence@@Rest[obj]]]];

SetAttributes[LinearClipDraw3D,HoldRest];

LinearClipDraw3D[obj_Graphics3D,
        rel_/;MemberQ[{Less,LessEqual,Greater,GreaterEqual},Head[rel]]&&
            Length[rel]\[Equal]2,var__Symbol,
        opts___Rule]/;(PolynomialQ[Subtract@@rel,{var}]&&
          Max[(Exponent[Expand[Subtract@@rel],#1]&)/@{var}]===1):=
    Block[{$DisplayFunction=Identity},
      LinearClipPlot3D[obj,rel,var,opts][[1]]];

LinearClipDraw3D[obj_SurfaceGraphics,other___]:=
    LinearClipDraw3D[Graphics3D[obj],other];

LinearClipDraw3D[obj_Graphics3D,
      rel_/;Or[MemberQ[{Less,LessEqual,Greater,GreaterEqual},Head[rel]]&&
            Length[rel]>2,Head[rel]===Inequality],var__Symbol,opts___Rule]:=
    Block[{$DisplayFunction=Identity},
      LinearClipPlot3D[obj,Evaluate@LogicalExpand[rel],var,opts][[1]]];

LinearClipDraw3D[obj_Graphics3D,rel_And,var__Symbol,opts___Rule]:=
    Block[{$DisplayFunction=Identity},
      Fold[LinearClipPlot3D[#1,#2,var,DisplayFunction\[Rule]Identity,opts]&,
          obj,List@@rel][[1]]];



SetAttributes[SliceSurfacePlot3D, HoldRest];

Options[SliceSurfacePlot3D]=
    Join[{Contours\[Rule]11,SurfaceStyle\[Rule]{EdgeForm[]},
        ContourStyle\[Rule]Automatic,ColorFunctionScaling\[Rule]True,
        OrientedCurve\[Rule]False,ShowProjectedLevelSets\[Rule]False,
        ProjectAt\[Rule]0,ArrowDensity\[Rule]1,ArrowPositions\[Rule]Automatic,
        ReverseOrientation\[Rule]False,
        DrawGraphics`DrawingArrows`HeadScaling3D\[Rule]Automatic,
        DrawGraphics`DrawingArrows`HeadLength3D\[Rule]1/10},
      Options[ParametricPlot3D]];

SliceSurfacePlot3D[obj_SurfaceGraphics,other___]:=
    SliceSurfacePlot3D[Graphics3D[obj],other];



SliceSurfacePlot3D[obj_Graphics3D,linForm_,x_Symbol,y_Symbol,z_Symbol,
        opts___?OptionQ]/;(PolynomialQ[linForm,{x,y,z}]&&
          Max[Map[Exponent[Expand[linForm],#]&,{x,y,z}]]===1):=
    Module[{projQ,zlev,sl,mshsty,ratObj,vertList,extremaOfLinForm,
        linearFormExcursion,lnsty,colorScalingQ,sliceList,sliceLineList,
        centralVal,srf,cntr,sliceLines,grad,gradNormalized,squishedLinesAdded,
        plotWithoutArrows,arwDnsty,pos,orientedQ,arw3Dcolor,
        maxLevelLineLength,howManyArrows,arrowPos,normalizedArrowPos,hdscl3D,
        addArrows,plotWithArrows},
      {projQ,
          zlev}={ShowProjectedLevelSets,ProjectAt}/.{opts}/.Options[
            SliceSurfacePlot3D];
      sl=Contours/.{opts}/.Options[SliceSurfacePlot3D];
      mshsty=Flatten[{SurfaceStyle}/.{opts}/.Options[SliceSurfacePlot3D]];
      ratObj=Rationalize[obj[[1]],1/10^6];
      triangulized=
        ratObj/.Polygon[{pt1_List,pts___}]\[RuleDelayed]
            Sequence@@Map[Polygon[Join[{pt1},#]]&,Partition[{pts},2,1]];
      vertList=
        Cases[ratObj,
          Polygon[pts_List]\[RuleDelayed]Sequence@@pts,{1,Infinity}];
      extremaOfLinForm={Min[#],Max[#]}&[
          linForm/.Map[Thread[{x,y,z}\[Rule]#]&,vertList]];
      linearFormExcursion=Abs[Subtract@@extremaOfLinForm];
      If[Chop@linearFormExcursion===0,
        Print["The object is flat in the direction of the slices"];Abort[]];
      {lnsty,
          colorScalingQ}={ContourStyle,ColorFunctionScaling}/.{opts}/.Options[
            SliceSurfacePlot3D];
      If[MatchQ[lnsty,Hue|GrayLevel|_Function],
        If[TrueQ@colorScalingQ,
          lnsty=Evaluate[
                lnsty[(#-First@extremaOfLinForm)/linearFormExcursion]]&],
        lnsty=(Evaluate[lnsty]&)];
      sliceList=
        Which[IntegerQ[sl]&&sl>0,
          Drop[Rest[
              Range@@(extremaOfLinForm~
                    Join~{Abs[Subtract@@extremaOfLinForm]/(sl+1)})],-1],
          MatchQ[sl,{val__?((NumericQ[#]&&FreeQ[N[#],Complex])&)}],sl,
          True,Print["can't handle these contours"];Abort[]];
      sliceList=Sort[sliceList,Less];
      sliceLineList={};
      {Graphics3D[triangulized],
          sliceList}//.{{gr_Graphics3D,
              valueList_List/;
                Length[valueList]\[GreaterEqual]2}\[RuleDelayed](centralVal=
                Floor[Length[valueList]/2];{{srf,cntr}=
                  LinearClipPlot3D[gr,
                      linForm\[LessEqual]valueList[[centralVal]],x,y,z,
                      DisplayFunction\[Rule]Identity,
                      PrepareForSlices\[Rule]True,
                      ContourStyle\[Rule]lnsty[valueList[[centralVal]]]]//
                    First;
                AppendTo[sliceLineList,{valueList[[centralVal]],cntr}];
                
                If[centralVal>1,{Graphics3D[srf],
                    Take[valueList,centralVal-1]},Sequence@@{}],
                {srf,cntr}=
                  LinearClipPlot3D[gr,
                      linForm\[GreaterEqual]valueList[[centralVal+1]],x,y,z,
                      DisplayFunction\[Rule]Identity,
                      PrepareForSlices\[Rule]True,
                      ContourStyle\[Rule]lnsty[valueList[[centralVal+1]]]]//
                    First;
                AppendTo[sliceLineList,{valueList[[centralVal+1]],cntr}];
                
                If[centralVal+1<Length[valueList],{Graphics3D[srf],
                    Drop[valueList,centralVal+1]},Sequence@@{}]}),
          {gr_Graphics3D,{value_}}\[RuleDelayed]({srf,cntr}=
                LinearClipPlot3D[gr,linForm\[LessEqual]value,x,y,z,
                    DisplayFunction\[Rule]Identity,
                    PrepareForSlices\[Rule]True,
                    ContourStyle\[Rule]lnsty[value]]//First;
              AppendTo[sliceLineList,{value,cntr}];Sequence@@{})};
      sliceLines=Sort[sliceLineList,First[#1]<First[#2]&][[All,-1]];
      grad=Outer[D,{linForm},{x,y,z}][[1]];
      gradNormalized=grad/Sqrt[grad.grad];
      squishedLinesAdded:=
        sliceLines/.(hd:(Line|Polygon))[pts_]\[RuleDelayed]{hd[pts],
              hd[Map[#-(gradNormalized.#)gradNormalized+
                      zlev*grad/(linForm/.Thread[{x,y,z}\[Rule]grad])&,
                  pts]]};
      plotWithoutArrows=
        Graphics3D[{Join[mshsty,ratObj],
            If[TrueQ@projQ,squishedLinesAdded,sliceLines]}];
      {arwDnsty,pos,orientedQ,
          arw3Dcolor}={ArrowDensity,ArrowPositions,OrientedCurve,
              Arrow3DColor}/.{opts}/.Options[LevelPlot3D];
      If[Not[TrueQ[orientedQ]],
        Return[Show[plotWithoutArrows,FilterOptions[Graphics3D,opts],
            DisplayFunction\[Rule]$DisplayFunction,BoxRatios\[Rule]Automatic,
            Rest[List@@obj]]]];
      If[MatchQ[arw3Dcolor,Hue|GrayLevel|_Function],
        If[TrueQ@colorScalingQ,
          arw3Dcolor=
            Evaluate[
                arw3Dcolor[(#-First@extremaOfLinForm)/linearFormExcursion]]&],
        arw3Dcolor=(Evaluate[arw3Dcolor]&)];
      maxLevelLineLength:=
        Max@@N[Cases[plotWithoutArrows,l_Line\[RuleDelayed]lineLength@@l,
              Infinity]];
      howManyArrows[pts_]:=
        Round[arwDnsty*3lineLength[pts]/maxLevelLineLength];
      arrowPos[pts_/;pos===Automatic]:=
        (Range[1,2#-1,2]/Max[2#,1]&)[howManyArrows[pts]];
      arrowPos[pts_/;pos=!=Automatic]:=Flatten[{pos}];
      normalizedArrowPos[pts_]:=((#-Min[#,0])/(Max[#,1]-Min[#,0])&)[
          arrowPos[pts]];
      hdscl3D=
        automaticHeadScaling3D[plotWithoutArrows,opts,
          Sequence@@Options[SliceSurfacePlot3D]];
      addArrows[pts_,linFormValue_]:={Line[pts],
          insertArrows[pts,normalizedArrowPos[pts],hdscl3D,
            Arrow3DColor\[Rule]arw3Dcolor[linFormValue],
            PlotStyle\[Rule]lnsty[linFormValue],opts,
            FilterOptions[DrawGraphics`DrawingArrows`Arrow3D,
              Options[SliceSurfacePlot3D]]]};
      plotWithArrows=plotWithoutArrows/.
          If[TrueQ@projQ,
            {Line[pts1_],
                Line[pts2_]}\[RuleDelayed](linFormValue=
                  linForm/.Thread[{x,y,z}\[Rule]First[pts1]];{addArrows[pts1,
                    linFormValue],addArrows[pts2,linFormValue]}),
            
            Line[pts_]\[RuleDelayed]Sequence@@
                addArrows[pts,linForm/.Thread[{x,y,z}\[Rule]First[pts]]]];
      Show[plotWithArrows,
        FilterOptions[Graphics3D,opts,BoxRatios\[Rule]Automatic,
          DisplayFunction\[Rule]$DisplayFunction,Rest[List@@obj]]]
      ];

SliceSurfaceDraw3D[obj_Graphics3D,linForm_,x_Symbol,y_Symbol,z_Symbol,
        opts___?OptionQ]/;(PolynomialQ[linForm,{x,y,z}]&&
          Max[Map[Exponent[Expand[linForm],#]&,{x,y,z}]]===1):=
    Block[{$DisplayFunction=Identity},
      SliceSurfacePlot3D[obj,linForm,x,y,z,opts][[1]]];



SetAttributes[LevelPlot3D,HoldAll];

Options[LevelPlot3D]=
    Join[{Contours\[Rule]11,SurfaceStyle\[Rule]{EdgeForm[]},
        ContourStyle\[Rule]Automatic,ShowProjectedLevelSets\[Rule]False,
        ProjectAt\[Rule]0,OrientedCurve\[Rule]False,ArrowDensity\[Rule]1,
        ArrowPositions\[Rule]Automatic,ReverseOrientation\[Rule]False,
        DrawGraphics`DrawingArrows`HeadScaling3D\[Rule]Automatic,
        DrawGraphics`DrawingArrows`HeadLength3D\[Rule]1/30},
      Options[ParametricPlot3D]];

LevelPlot3D[f_,{x_Symbol,xMin_,xMax_},{y_Symbol,yMin_,yMax_},opts___]:=
    Module[{z},
      SliceSurfacePlot3D[
        Plot3D[f,{x,xMin,xMax},{y,yMin,yMax},DisplayFunction\[Rule]Identity,
          Evaluate[FilterOptions[Plot3D,opts]]],z,x,y,z,opts]];

LevelDraw3D[x__]:=Block[{$DisplayFunction=Identity},
      LevelPlot3D[x][[1]]];



End[];

Protect["`*"];

EndPackage[];

On[General::"spell1"]

On[General::"spell"]

















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































